<?php
   function vidopticon_ads_panel()
   {
   ?>
<div class="wp-header-end"></div>
<div class="wrap gs_popuptype_holder seo_pops">
   <div>
      <form id="myForm" method="post" action="admin.php?page=vidopticon_ads_panel">
         <?php
            wp_nonce_field('vidopticon_save_rules', '_vidopticonr_nonce');
            if (isset($_GET['settings-updated'])) {
            ?>
         <div>
            <p class="cr_saved_notif"><strong><?php echo esc_html__("Settings saved.", 'vidopticon-video-search-engine');?></strong></p>
         </div>
         <?php
            }
            ?>
         <div>
            <div class="hideMain">
               <h3><?php echo esc_html__("These ads will appear between search results for users:", 'vidopticon-video-search-engine');?></h3>
               <hr/>
               <div class="table-responsive">
                  <table class="responsive table cr_main_table">
                     <thead>
                        <tr>
                           <th class="cr_min_100">
                              <?php echo esc_html__("ID", 'vidopticon-video-search-engine');?>
                              <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                 <div class="bws_hidden_help_text cr_min_260px">
                                    <?php
                                       echo esc_html__("This is the ID of the rule.", 'vidopticon-video-search-engine');
                                       ?>
                                 </div>
                              </div>
                           </th>
                           <th class="cr_200">
                              <?php echo esc_html__("Where To Show Ad", 'vidopticon-video-search-engine');?>
                              <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                 <div class="bws_hidden_help_text cr_min_260px">
                                    <?php
                                       echo esc_html__("Select the type of the ad (where it should appear).", 'vidopticon-video-search-engine');
                                       ?>
                                 </div>
                              </div>
                           </th>
                           <th>
                              <?php echo esc_html__("Ad Code", 'vidopticon-video-search-engine');?>
                              <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                 <div class="bws_hidden_help_text cr_min_260px">
                                    <?php
                                       echo esc_html__("Input the HTML code for the Ad.", 'vidopticon-video-search-engine');
                                       ?>
                                 </div>
                              </div>
                           </th>
                           <th>
                              <?php echo esc_html__("More Options", 'vidopticon-video-search-engine');?>
                              <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                 <div class="bws_hidden_help_text cr_min_260px">
                                    <?php
                                       echo esc_html__("Shows advanced settings for this rule.", 'vidopticon-video-search-engine');
                                       ?>
                                 </div>
                              </div>
                           </th>
                           <th class="cr_80">
                              <?php echo esc_html__("Del", 'vidopticon-video-search-engine');?>
                              <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                 <div class="bws_hidden_help_text cr_min_260px">
                                    <?php
                                       echo esc_html__("Do you want to delete this rule?", 'vidopticon-video-search-engine');
                                       ?>
                                 </div>
                              </div>
                           </th>
                           <th class="cr_80">
                              <?php echo esc_html__("Active", 'vidopticon-video-search-engine');?>
                              <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                 <div class="bws_hidden_help_text cr_min_260px">
                                    <?php
                                       echo esc_html__("Do you want to enable this rule? You can deactivate any rule (you don't have to delete them to deactivate them).", 'vidopticon-video-search-engine');
                                       ?>
                                 </div>
                              </div>
                              <br/>
                              <input type="checkbox" onchange="thisonChangeHandler(this)" id="exclusion">
                           </th>
                        </tr>
                        <tr>
                           <td>
                              <hr/>
                           </td>
                           <td>
                              <hr/>
                           </td>
                           <td>
                              <hr/>
                           </td>
                           <td>
                              <hr/>
                           </td>
                           <td>
                              <hr/>
                           </td>
                           <td>
                              <hr/>
                           </td>
                        </tr>
                     </thead>
                     <tbody>
                        <?php
                           echo vidopticon_expand_rules_ads();
                           ?>
                        <tr>
                           <td>
                              <hr/>
                           </td>
                           <td>
                              <hr/>
                           </td>
                           <td>
                              <hr/>
                           </td>
                           <td>
                              <hr/>
                           </td>
                           <td>
                              <hr/>
                           </td>
                           <td>
                              <hr/>
                           </td>
                        </tr>
                        <tr>
                           <td class="cr_short_td">
                              -&nbsp;
                              <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                 <div class="bws_hidden_help_text cr_min_260px">
                                    <?php
                                       echo esc_html__("No info.", 'vidopticon-video-search-engine');
                                       ?>
                                 </div>
                              </div>
                           </td>
                           <td class="cr_centered">
                              <select class="pnpads" id="ad_type" name="vidopticon_ad_list[ad_type][]" class="cr_200">
                                 <option value="youtube" selected><?php echo esc_html__("YouTube Search", 'vidopticon-video-search-engine');?></option>
                              </select>
                           </td>
                           <td class="cr_centered"><textarea rows="1" name="vidopticon_ad_list[ad_html][]" class="cr_width_full" class="pnpads" placeholder="Input your ad code"></textarea></td>
                           <td class="cr_width_70">
                              <input type="button" id="mybtnfzr" value="Settings">
                              <div id="mymodalfzr" class="codemodalfzr">
                                 <div class="codemodalfzr-content">
                                    <div class="codemodalfzr-header">
                                       <span id="vidopticon_close" class="codeclosefzr">&times;</span>
                                       <h2><span class="cr_color_white"><?php echo esc_html__("New Rule", 'vidopticon-video-search-engine');?></span> <?php echo esc_html__("Advanced Settings", 'vidopticon-video-search-engine');?></h2>
                                    </div>
                                    <div class="codemodalfzr-body">
                                       <div class="table-responsive">
                                          <table class="responsive table cr_main_table_nowr">
                                             </td></tr>
                                             <tr>
                                                <td class="cr_min_200"colspan="2">
                                                   <h3><?php echo esc_html__("Ad Manager Advanced Settings:", 'vidopticon-video-search-engine');?></h3>
                                                </td>
                                             </tr>
                                             <tr>
                                                <td>
                                                   <div>
                                                      <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                                         <div class="bws_hidden_help_text cr_min_260px">
                                                            <?php
                                                               echo esc_html__("Set the start date when you wish to start showing this ad.", 'vidopticon-video-search-engine');
                                                               ?>
                                                         </div>
                                                      </div>
                                                      <b><?php echo esc_html__("Start Showing Ad At This Date:", 'vidopticon-video-search-engine');?></b>
                                                </td>
                                                <td>
                                                <input class="vidopticon_start" type="text" name="vidopticon_ad_list[vidopticon_start][]" value="" placeholder="Ad start date" class="cr_width_full">
                                                </div>
                                                </td>
                                             </tr>
                                             <tr>
                                                <td>
                                                   <div>
                                                      <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                                         <div class="bws_hidden_help_text cr_min_260px">
                                                            <?php
                                                               echo esc_html__("Set the end date when you wish to start showing this ad.", 'vidopticon-video-search-engine');
                                                               ?>
                                                         </div>
                                                      </div>
                                                      <b><?php echo esc_html__("End Showing Ad At This Date:", 'vidopticon-video-search-engine');?></b>
                                                </td>
                                                <td>
                                                <input class="vidopticon_end" type="text" name="vidopticon_ad_list[vidopticon_end][]" value="" placeholder="Ad end date" class="cr_width_full">
                                                </div>
                                                </td>
                                             </tr>
                                             <tr>
                                                <td>
                                                   <div>
                                                      <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                                         <div class="bws_hidden_help_text cr_min_260px">
                                                            <?php
                                                               echo esc_html__("In case you don't want to search ad content for keywords (or it is an image ad - without usable keywords), you should insert here a space separated list of keywords. This list will be used when searching for an ad to be displayed for users - based on their query string entered in the search box.", 'vidopticon-video-search-engine');
                                                               ?>
                                                         </div>
                                                      </div>
                                                      <b><?php echo esc_html__("Ad Keywords:", 'vidopticon-video-search-engine');?></b>
                                                </td>
                                                <td>
                                                <input class="vidopticon_keywords" type="text" name="vidopticon_ad_list[vidopticon_keywords][]" value="" placeholder="Ad keyword list" class="cr_width_full">
                                                </div>
                                                </td>
                                             </tr>
                                          </table>
                                       </div>
                                    </div>
                                    <div class="codemodalfzr-footer">
                                       <br/>
                                       <h3 class="cr_inline">Vidopticon Ad Manager</h3>
                                       <span id="vidopticon_ok" class="codeokfzr cr_inline">OK&nbsp;</span>
                                       <br/><br/>
                                    </div>
                                 </div>
                              </div>
                           </td>
                           <td class="cr_shrt_td2"><span class="cr_gray20">X</span></td>
                           <td class="cr_short_td"><input class="pnpads" type="checkbox" name="vidopticon_ad_list[active][]" value="1" checked /></td>
                        </tr>
                     </tbody>
                  </table>
               </div>
            </div>
         </div>
         <hr/>
         <div>
            <p class="crsubmit"><input type="submit" name="btnSubmit" id="btnSubmit" class="button button-primary" onclick="unsaved = false;" value="<?php echo esc_html__("Save Settings", 'vidopticon-video-search-engine');?>"/></p>
         </div>
      </form>
   </div>
</div>
<?php
   }
   if (isset($_POST['vidopticon_ad_list'])) {
       add_action('admin_init', 'vidopticon_save_rules_ads');
   }
   
   function vidopticon_save_rules_ads($data2)
   {
       check_admin_referer('vidopticon_save_rules', '_vidopticonr_nonce');
       
       $data2 = $_POST['vidopticon_ad_list'];
       $rules = array();
       $cont  = 0;
       if (isset($data2['ad_html'][0])) {
           for ($i = 0; $i < sizeof($data2['ad_html']); ++$i) {
               $bundle = array();
               if (isset($data2['ad_html'][$i]) && $data2['ad_html'][$i] != '') {
                   $bundle[]     = trim(sanitize_text_field($data2['ad_type'][$i]));
                   $bundle[]     = trim($data2['ad_html'][$i]);
                   if (isset($data2['active'][$i])) {
                       $bundle[] = trim(sanitize_text_field($data2['active'][$i]));
                   } else {
                       $bundle[] = '0';
                   }
                   $bundle[]     = trim(sanitize_text_field($data2['vidopticon_start'][$i]));
                   $bundle[]     = trim(sanitize_text_field($data2['vidopticon_end'][$i]));
                   $bundle[]     = trim(sanitize_text_field($data2['vidopticon_keywords'][$i]));
                   $rules[$cont] = $bundle;
                   $cont++;
               }
           }
       }
       update_option('vidopticon_ad_list', $rules, false);
   }
   function vidopticon_expand_rules_ads()
   {
       if (!get_option('vidopticon_running_list')) {
           $running = array();
       } else {
           $running = get_option('vidopticon_running_list');
       }
       $rules  = get_option('vidopticon_ad_list');
    if(!is_array($rules))
    {
       $rules = array();
    }
       $output = '';
       $cont   = 0;
       if (!empty($rules)) {
           foreach ($rules as $request => $bundle[]) {
               $bundle_values          = array_values($bundle);
               $myValues               = $bundle_values[$cont];
               $array_my_values        = array_values($myValues);for($iji=0;$iji<count($array_my_values);++$iji){if(is_string($array_my_values[$iji])){$array_my_values[$iji]=stripslashes($array_my_values[$iji]);}} 
               $ad_type                = $array_my_values[0];
               $ad_html                = $array_my_values[1];  
               $active                 = $array_my_values[2];
               $vidopticon_start       = $array_my_values[3];
               $vidopticon_end         = $array_my_values[4];
               $vidopticon_keywords    = $array_my_values[5];
               wp_add_inline_script('vidopticon-footer-script', 'createAdmin(' . esc_html($cont) . ');', 'after');
               $output .= '<tr>
                           <td class="cr_short_td">' . esc_html($cont) . '&nbsp;<div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                           <div class="bws_hidden_help_text cr_min_260px">';
               $now     = vidopticon_get_date_now();
               $output .= 'Local Time: ' . $now;
               $output .= '</div>
                       </div></td>
   						<td class="cr_centered"><select class="pnpads" id="ad_type" name="vidopticon_ad_list[ad_type][]" class="cr_200">
                                     <option value="youtube"';
               if ($ad_type == 'youtube') {
                   $output .= ' selected';
               }
               $output .= '>' . esc_html__("YouTube Search", 'vidopticon-video-search-engine') . '</option>
                       </select>  </td>
                       <td class="cr_centered">
                       <textarea rows="1" name="vidopticon_ad_list[ad_html][]" class="cr_width_full" class="pnpads" required placeholder="Input your ad code">' . esc_textarea($ad_html) . '</textarea></td>
                       <td class="cr_width_70">
                       <input type="button" id="mybtnfzr' . esc_html($cont) . '" value="Settings">
                       <div id="mymodalfzr' . esc_html($cont) . '" class="codemodalfzr">
     <div class="codemodalfzr-content">
       <div class="codemodalfzr-header">
         <span id="vidopticon_close' . esc_html($cont) . '" class="codeclosefzr">&times;</span>
         <h2>' . esc_html__('Rule', 'vidopticon-video-search-engine') . ' <span class="cr_color_white">ID ' . esc_html($cont) . '</span> ' . esc_html__('Advanced Settings', 'vidopticon-video-search-engine') . '</h2>
       </div>
       <div class="codemodalfzr-body">
       <div class="table-responsive">
         <table class="responsive table cr_main_table_nowr">
           </td></tr><tr><td>
           <div>
           <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                           <div class="bws_hidden_help_text cr_min_260px">' . esc_html__("Set the start date when you wish to start showing this ad.", 'vidopticon-video-search-engine') . '
                           </div>
                       </div>
                       <b>' . esc_html__("Start Showing Ad At This Date", 'vidopticon-video-search-engine') . ':</b>
                       
                       </td><td>
                       <input class="vidopticon_start" type="text" name="vidopticon_ad_list[vidopticon_start][]" value="' . esc_attr($vidopticon_start) . '" placeholder="Ad start date" class="cr_width_full">
                           
           </div>
           </td></tr><tr><td>
           <div>
           <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                           <div class="bws_hidden_help_text cr_min_260px">' . esc_html__("Set the end date when you wish to start showing this ad.", 'vidopticon-video-search-engine') . '
                           </div>
                       </div>
                       <b>' . esc_html__("End Showing Ad At This Date", 'vidopticon-video-search-engine') . ':</b>
                       
                       </td><td>
                       <input class="vidopticon_end" type="text" name="vidopticon_ad_list[vidopticon_end][]" value="' . esc_attr($vidopticon_end) . '" placeholder="Ad end date" class="cr_width_full">
                           
           </div>
           </td></tr><tr><td>
           <div>
           <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                           <div class="bws_hidden_help_text cr_min_260px">' . esc_html__("In case you don\'t want to search ad content for keywords (or it is an image ad - without usable keywords), you should insert here a space separated list of keywords. This list will be used when searching for an ad to be displayed for users - based on their query string entered in the search box.", 'vidopticon-video-search-engine') . '
                           </div>
                       </div>
                       <b>' . esc_html__("Ad Keywords", 'vidopticon-video-search-engine') . ':</b>
                       
                       </td><td>
                       <input class="vidopticon_keywords" type="text" name="vidopticon_ad_list[vidopticon_keywords][]" value="' . esc_attr($vidopticon_keywords) . '" placeholder="Ad keyword list" class="cr_width_full">
                           
           </div>
           </td></tr></table></div> 
       </div>
       <div class="codemodalfzr-footer">
         <br/>
         <h3 class="cr_inline">Vidopticon Ad Manager</h3><span id="vidopticon_ok' . esc_html($cont) . '" class="codeokfzr cr_inline">OK&nbsp;</span>
         <br/><br/>
       </div>
     </div>
   
   </div>       
                       </td>
   						<td class="cr_shrt_td2"><span class="wpvidopticon-delete">X</span></td>
                           <td class="cr_short_td"><input class="pnpads activateDeactivateClass" type="checkbox" name="vidopticon_ad_list[active][]" value="1"';
               if (isset($active) && $active === '1') {
                   $output .= ' checked';
               }
               $output .= '/></td>
   					</tr>	
   					';
               $cont = $cont + 1;
           }
       }
       return $output;
   }
   ?>